package com.blackledge.david.html;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import com.blackledge.david.html.hme.HTMLBreakdown;

public class HTMLFormSelect extends HTMLFormField {

	public LinkedHashMap<String, String> valuesDisplays;
//	public String selected;
	public ArrayList<Integer> selectedIndices = new ArrayList<Integer>();

	public HTMLFormSelect(String form, String name, String type, String values,
			Object textFont, boolean isBold, boolean isItalic, int textSize) {
		super(form, name, type, textFont, isBold, isItalic, textSize);
		int index = values.indexOf('\n');
		if(index < 0) index = values.length();
		//FIXME support multiple selections separated by something, allow for when the value is null, too.
		String selected = values.substring(0, index);
		if(index < values.length()) {
			values = values.substring(index+1);
		} else {
			values = "";
		}
		LinkedHashMap<String, String> vals = new LinkedHashMap<String, String>();
		String[] entries = values.split("\n");
		for(String entry : entries) {
			String[] dispVal = entry.split("\t");
			if(dispVal.length == 1) {
				vals.put(null, 
						HTMLBreakdown.fixTextForRendering(dispVal[0]));
				if(selected == null) {
					selectedIndices.add( vals.size()-1 );
				}
			} else if(dispVal.length > 1) { // could be 0 if entry=="\t"
				vals.put(dispVal[1],
						HTMLBreakdown.fixTextForRendering(dispVal[0]));
				if(dispVal[1].equals(selected)) {
					selectedIndices.add(vals.size()-1);
				}
			}
		}
		this.valuesDisplays = vals;
	}
	
	@Override
	public List<? extends String[]> getSubmissions() {
		ArrayList<String[]> submissions = new ArrayList<String[]>();
		if(!this.disabled) {
			if(selectedIndices.size() > 0) {
				 Iterator<String> values = this.valuesDisplays.keySet().iterator();
				 int index = 0;
				 while(values.hasNext()) {
					 String value = values.next();
					 if(selectedIndices.contains(index)) {
						 submissions.add(new String[] {this.name, value});
					 }
					 ++index;
				 }
			}
			//FIXME if multi-select... (already works? or do we need to do this?)
//			if(selected != null) {
//				if(this.name != null) {
//					submissions.put(this.name, selected);
//				}
//			}
		}
		System.out.println((this.disabled?"(disabled)":"submission:")+"select - "+this.name+"="+selectedIndices);
		return submissions;
	}

}
