package com.blackledge.david.html;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class HTMLFormTextarea extends HTMLFormField {

	public String contents;
	private String cols;
	private String rows;

	public HTMLFormTextarea(String name, String contents, String formSpec, Object textFont,
			boolean isBold, boolean isItalic, int textSize) {
		super(formSpec, name.substring(0,name.indexOf("|")), "textarea", textFont, isBold, isItalic, textSize);
		this.contents = contents;
		String size = name.substring(name.indexOf("|")+1);
		this.cols = size.substring(0, size.indexOf("x"));
		this.rows = size.substring(size.indexOf("x")+1);
		
	}
	
	@Override
	public List<? extends String[]> getSubmissions() {
		ArrayList<String[]> submissions = new ArrayList<String[]>();
		if(!this.disabled) {
			if(this.name != null)
			submissions.add(new String[] {this.name, this.contents});
		}
		return submissions;
	}
 
	public String getCols() {
		return cols;
	}
	
	public String getRows() {
		return rows;
	}
}
