package com.blackledge.david.html;

import java.awt.Color;

public class HTMLStyleChunk extends HTMLChunk {

	public Color color;
	public boolean isLocalColor;
	public boolean isItalic;
	public boolean isBold;
	public Object font;
	public int fontSize;
	
	public HTMLStyleChunk() {
		super();
	}

	public String getFontString(float fontSizePercent) {
		String fontFamily = translateFont(this.font);
		String style = null;
		if(isBold && isItalic) {
			style = "bolditalic";
		} else if(isBold) {
			style = "bold";
		} else if(isItalic) {
			style = "italic";
		}
		int size = this.fontSize;
//		System font shows up a little larger than default font.
		if(fontFamily.equals("system") && size > 3) {
			size -= 3;
		}
		if(style != null) {
			return fontFamily+"-"+(int)(size*fontSizePercent)+"-"+style+".font";
		} else {
			return fontFamily+"-"+(int)(size*fontSizePercent)+".font";
		}
	}

	private String translateFont(Object font2) {
//		'serif' (e.g., Times)
//		'sans-serif' (e.g., Helvetica)
//		'cursive' (e.g., Zapf-Chancery)
//		'fantasy' (e.g., Western)
//		'monospace' (e.g., Courier)

		//TODO do a better translation
		String fontFamily = String.valueOf(font2).toLowerCase();
		if (fontFamily.equals("sans-serif") || fontFamily.equals("monospace") || fontFamily.equals("system"))
			return "system";
		else
			return "default";
	}
	
	public boolean sameBaseStyleAs(HTMLStyleChunk otherChunk) {
		if(otherChunk == null) return true;
		return equal(this.font, otherChunk.font)
				&& this.isBold == otherChunk.isBold
				&& this.isItalic == otherChunk.isItalic
				&& this.fontSize == otherChunk.fontSize;
		
	}

	private boolean equal(Object a, Object b) {
		if (a == null)
			return b == null;
		if (b == null)
			return false;
		return a.equals(b);
	}

}