package com.blackledge.david.html.hme;

import com.tivo.hme.bananas.BHighlights;
import com.tivo.hme.bananas.BRect;
import com.tivo.hme.bananas.BView;

public class BLinkView extends BView {

	private String link;

	public BLinkView(String link, BView parent, int x, int y, int width, int height,
			boolean visible) {
		super(parent, x, y, width, height, visible);
		init(link);
	}

	private void init(String link) {
		this.link = link;
		setFocusable(true);
		setHighlights();
	}

	private void setHighlights() {
		getHighlights().setWhisperingArrow(BHighlights.H_RIGHT,
				BHighlights.A_RIGHT+10,
				BHighlights.A_CENTER, "right");
		getHighlights().setWhisperingArrow(BHighlights.H_LEFT,
				BHighlights.A_LEFT-10,  
				BHighlights.A_CENTER, "left");
		getHighlights().setWhisperingArrow(BHighlights.H_UP,
				 BHighlights.A_CENTER, 
				 BHighlights.A_TOP-10, "up");
		getHighlights().setWhisperingArrow(BHighlights.H_DOWN,
				 BHighlights.A_CENTER, 
				 BHighlights.A_BOTTOM+10, "down");
	}

	public BLinkView(String link, BView parent, int x, int y, int width, int height) {
		super(parent, x, y, width, height);
		init(link);
	}

	public String getLink() {
		return link;
	}
	
	/**
	 * resets the highlights, too
	 */
	@Override
	public void setSize(int width, int height) {
		super.setSize(width, height);
		setHighlights();
	}

}
