package com.blackledge.david.html.hme;

import java.awt.Color;
import java.awt.Rectangle;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;

import com.blackledge.david.html.HTMLRow;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

public class BRowBGView extends BView {

	private ArrayList<BRowView> rows = new ArrayList<BRowView>();
	
	public BRowBGView(BView bgParent, int x, int y, int width, int height) {
		super(bgParent, x, y, width, height);
	}
	
	public void addRow(BRowView row) {
//		if(!rows.contains(row)) {
//			Rectangle b = getBounds().union(row.getBounds());
//			WebBrowserApp.debugOut("added bg row "+getBounds()+" + "+row.getBounds()+" = "+b);
//			setBounds(b.x, b.y, b.width, b.height);
//		}
		rows.add(row);
		updateHeight(null);
	}
	
	public BRowView removeRow(BRowView row) {
		rows.remove(row);
		updateHeight(null);
//		if(!rows.contains(row)) {
//			if(getY() == row.getY()) {
//				// this was the top row.
//				setBounds(getX(), getY()+row.getHeight(), getWidth(), getHeight()-row.getHeight());
//				WebBrowserApp.debugOut("removed bg top row "+row.getHeight()+", now "+getBounds());
//			} else if(getY()+getHeight() == row.getY()+row.getHeight()) {
//				// this was the bottom row
//				setBounds(getX(), getY(), getWidth(), getHeight()-row.getHeight());
//				WebBrowserApp.debugOut("removed bg bottom row "+row.getHeight()+", now "+getBounds());
//			} else {
//				// uhh.... removed a row in the middle? this will cause problems later.
//				WebBrowserApp.debugOut("remove bg row !!! problem ! it was in the middle??"+row.getBounds()+" vs bg "+getBounds());
//			}
//		}
		BRowView top = null;
		if(row.isBGTopOwner() && rows.size() > 0) {
			top = rows.get(0);
			for(BRowView item : rows) {
				if(item.rowIndex < top.rowIndex) {
					top = item;
				}
			}
		}
		return top;
	}

	void updateHeight(Resource animation) {
		if(rows.size() > 0) {
			//TODO could do this faster since we only care about y and height
			Rectangle b = rows.get(0).getBounds();
			for(int i = 0 ; i < rows.size(); ++i) {
				b = b.union(rows.get(i).getBounds());
//				WebBrowserApp.debugOut("BG update row "+i+" bounds "+rows.get(i).getBounds());
			}
//			if(!getBounds().equals(b))
//				WebBrowserApp.debugOut("BG update "+rows.size()+" rows from "+getBounds()+" to "+b);
			setBounds(getX(), b.y, getWidth(), b.height, animation);
		}
	}

	public void setBG(URL baseURL, String bg, Color bgcolor, int bgrepeat, int bgposition) {
		if(bg != null) {
			try {
				HTMLBreakdown.setupInlineBackground(this, baseURL, bg, bgposition, bgrepeat);
//	//			WebBrowserApp.debugOut("!!!set "+row.getClass()+" bg to "+new URL(baseURL, row.bg));
//				URL bgu = new URL(baseURL, bg);
//				int flags = getResourceFlags(bg, bgrepeat, bgposition);
//				Resource res = getResource(bgu);
//				res.addHandler(new InlineBackgroundResourceHandler(this, bgu, res, bgrepeat, bgposition));
//				setResource(res, flags);
//				return;
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		//FIXME actually this view doesn't need to handle color at all...its parent does that.
		else//FIXME need to handle both
		if(bgcolor != null) {
//			WebBrowserApp.debugOut("!!!set "+row.getClass()+" bg to "+row.bgcolor);
			setResource(bgcolor);
		}
		
	}

	static int getResourceFlags(String bg, int bgrepeat, int bgposition) {
		int flags = 0;
		if(bgrepeat < 0) bgrepeat = HTMLRow.ROW_BG_REPEAT_DEFAULT;
		if(bgposition < 0) bgposition = HTMLRow.ROW_BG_POSITION_DEFAULT;
		if(bgrepeat > -1 && bgrepeat != HTMLRow.ROW_BG_REPEAT_NONE) {
			if(bgrepeat == HTMLRow.ROW_BG_REPEAT_BOTH || bgrepeat == HTMLRow.ROW_BG_REPEAT_X) {
				flags |= Resource.RSRC_IMAGE_HFIT;
			}
			if(
					//bgrepeat == HTMLRow.ROW_BG_REPEAT_BOTH || 
					bgrepeat == HTMLRow.ROW_BG_REPEAT_Y) {
				flags |= Resource.RSRC_IMAGE_HFIT;
			}
		}
		if(bgposition > -1) {
			int horizontal = bgposition/1000;
			int vertical = bgposition - horizontal;
			if(horizontal == 50) {
				flags |= Resource.RSRC_HALIGN_CENTER;
			}
			else if(horizontal == 0) {
				flags |= Resource.RSRC_HALIGN_LEFT;
			}
			else if(horizontal == 100) {
				flags |= Resource.RSRC_HALIGN_RIGHT;
			}
			if(vertical == 50) {
				flags |= Resource.RSRC_VALIGN_CENTER;
			}
			else if(vertical == 0) {
				flags |= Resource.RSRC_VALIGN_TOP;
			}
			else if(vertical == 100) {
				flags |= Resource.RSRC_VALIGN_BOTTOM;
			}
			
		}
WebBrowserApp.debugOut("set row bg view with flags "+Integer.toHexString( flags)+" from "+bgrepeat+" and "+bgposition+" for "+bg);
		return flags;
	}

}
