package com.blackledge.david.html.hme;

import java.awt.Color;

import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlights;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;

public class FormButton extends BView {

	private Object form;
	private String name;
	private Object action;
	private BView label;

	public FormButton(Object object, String name, BView parent, int x, int y, int width, int height) {
		// +(width%2==1?1:0):  to adjust evenness of width to prevent overlap of left/right halves
		super(parent, x, y, getWidth(width)
				, getHeight(height));
		this.name = name;
		init(object);
	}

	public static int getHeight(int height) {
		return height+10;
	}

	public static int getWidth(int width) {
		return width+20
//				+(width%2==1?1:0)
;
	} 
	
	 void updateButton(String value, Color labelColor, String fontString) {
// System.out.println("updateButton "+value);
		 createLabel();
		 if(labelColor == null) labelColor = Color.white;
		 label.setResource(label.createText(fontString, labelColor, value));
	}

	private void createLabel() {
		if(label == null)
			label = new BView(this, 10, 5, getWidth()-20, getHeight()-10);
	}

	private void init(Object form) {
		this.form = form;
		
		Element barSkin = getBApp().getSkin().get(H_BAR);
		BView barLeft = new BView(this, 0, 0, this.getWidth()/2, this.getHeight());
		//NOTE 1 pixel gap on simulator, but otherwise 1 pixel overlap on TiVo
		BView barRight = new BView(this, this.getWidth()/2
//				/**/+1
				, 0, this.getWidth()-this.getWidth()/2, this.getHeight());
		barLeft.setResource(barSkin.getResource(), RSRC_HALIGN_LEFT| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
		barRight.setResource(barSkin.getResource(), RSRC_HALIGN_RIGHT| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
		
		setFocusable(true);
		getHighlights().setWhisperingArrow(BHighlights.H_RIGHT,
				BHighlights.A_RIGHT+10,
				BHighlights.A_CENTER, "right");
		getHighlights().setWhisperingArrow(BHighlights.H_LEFT,
				BHighlights.A_LEFT-10,  
				BHighlights.A_CENTER, "left");
		getHighlights().setWhisperingArrow(BHighlights.H_UP,
				 BHighlights.A_CENTER, 
				 BHighlights.A_TOP-10, "up");
		getHighlights().setWhisperingArrow(BHighlights.H_DOWN,
				 BHighlights.A_CENTER, 
				 BHighlights.A_BOTTOM+10, "down");
	}

	public Object getForm() {
		return form;
	}
	
	public String getName() {
		return name;
	}
	
	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if(code == KEY_SELECT) {
			postEvent(new BEvent.Action(this, getAction()));
			return true;
		} else {
			return super.handleKeyPress(code, rawcode);
		}
	}

	private Object getAction() {
		return this.action;
	}
	
	public void setAction(Object action) {
		this.action = action;
	}
	
}
