package com.blackledge.david.html.hme;

import java.awt.Color;

import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlights;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

public class FormCheck extends BView {

	private Object form;
	private String name;
	private Object action;
	private BView label;

	public FormCheck(Object object, String name, BView parent, int x, int y, int width, int height) {
		super(parent, x, y, getWidth(width), getHeight(height));
		this.name = name;
		init(object);
	}
	
	public static int getWidth(int width) {
		return width;
	}
	
	public static int getHeight(int height) {
		return height;
	}
	

	private void init(Object form) {
		this.form = form;
		
		Resource r = getBApp().getSkin().get(H_KEYBOARD).getResource();
		setResource(r, RSRC_HALIGN_CENTER| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);

		setFocusable(true);
		getHighlights().setWhisperingArrow(BHighlights.H_RIGHT,
				BHighlights.A_RIGHT+10,
				BHighlights.A_CENTER, "right");
		getHighlights().setWhisperingArrow(BHighlights.H_LEFT,
				BHighlights.A_LEFT-10,  
				BHighlights.A_CENTER, "left");
		getHighlights().setWhisperingArrow(BHighlights.H_UP,
				 BHighlights.A_CENTER, 
				 BHighlights.A_TOP-10, "up");
		getHighlights().setWhisperingArrow(BHighlights.H_DOWN,
				 BHighlights.A_CENTER, 
				 BHighlights.A_BOTTOM+10, "down");
	}
	

	 void updateCheck(String type, boolean checked, Color labelColor,
			String fontString) {
		 createLabel();

			if(labelColor == null) labelColor = Color.black;
		if (type.equals("checkbox")) {
			label.setResource(label.createText(fontString, labelColor,
					checked ? "X" : "_"));
		} else {
			label.setResource(label.createText(fontString, labelColor,
					checked ? " * ":"   "));
		}
	}

	private void createLabel() {
		if(label == null)		label = new BView(this, 0, 0, this.getWidth(), this.getHeight());
	} 


	public Object getForm() {
		return form;
	}

	public String getName() {
		return name;
	}
	
	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if(code == KEY_SELECT) {
			postEvent(new BEvent.Action(this, getAction()));
			return true;
		} else {
			return super.handleKeyPress(code, rawcode);
		}
	}
	
	private Object getAction() {
		return this.action;
	}
	
	public void setAction(Object action) {
		this.action = action;
	}

}
