package com.blackledge.david.html.hme;

import java.awt.Color;

import com.blackledge.david.html.HTMLFormField;
import com.blackledge.david.html.HTMLFormInput;
import com.blackledge.david.html.HTMLFormTextarea;
import com.blackledge.david.tivo.widgets.typo.TyPo;
import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlights;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.IHmeProtocol;
import com.tivo.hme.sdk.Resource;

public class FormInput extends BView {

	private Object form;
	private String name;
	private Object action;
	private BView label;
	private boolean activated = false;

	public FormInput(Object object, String name, BView parent, int x, int y, int width, int height) {
		// +(width%2==1?1:0) :  to adjust evenness of width to prevent overlap of left/right halves
		super(parent, x, y, getWidth(width)
				, getHeight(height));
		this.name = name;

		init(object);
	}
	public static int getHeight(int height) {
		return height+10;
	} 
	public static int getWidth(int width) {
		return width+20
//		+(width%2==1?1:0)
				;
		}
	
	void updateTextarea(String value, Color labelColor, String fontString) {
		createLabel();

		if(labelColor == null) labelColor = Color.white;
		if(label.getResource() != null) label.getResource().remove();
		label.setResource(label.createText(fontString, labelColor, value),
				IHmeProtocol.RSRC_TEXT_WRAP | IHmeProtocol.RSRC_HALIGN_LEFT
						| IHmeProtocol.RSRC_VALIGN_TOP);
	}

	private void createLabel() {
		if(label==null)		 label = new BView(this, 10, 5, getWidth()-20, getHeight()-10);
	}

	 void updateText(String type, String value, Color labelColor,
			String fontString) {
		 createLabel();
// System.out.println("updateText "+value);
			if(labelColor == null) labelColor = Color.white;
			if(label.getResource() != null) label.getResource().remove();
		if(type != null && type.equals("password")) {
			label.setResource(label.createText(fontString, labelColor,
					((value == null || value.length() == 0) ? "" : "*****")));
		} else {
			int flags = RSRC_HALIGN_LEFT | RSRC_VALIGN_CENTER;
			//TODO this should be based on field width and value calculated width
			if(value.length() > getWidth()/12)
				flags = RSRC_HALIGN_RIGHT | RSRC_VALIGN_CENTER;
			label.setResource(label.createText(fontString, labelColor, value), flags);
		}
	}

	private void init(Object form) {
		this.form = form;
		
//		Resource r = getBApp().getSkin().get("keyboard-datafield").getResource();
//		Resource r = getBApp().getSkin().get(H_KEYBOARD).getResource();
		Resource r = getResource("com/tivo/hme/bananas/keyboard-datafield.png");
		BView barLeft = new BView(this, 0, 0, this.getWidth()/2, this.getHeight());
		//NOTE 1 pixel gap on simulator, but otherwise 1 pixel overlap on TiVo [not for datafield, though?]
		BView barRight = new BView(this, this.getWidth()/2
				/*+1*/
				, 0, this.getWidth()-this.getWidth()/2, this.getHeight());
		barLeft.setResource(r, RSRC_HALIGN_LEFT| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
		barRight.setResource(r, RSRC_HALIGN_RIGHT| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
		
		setFocusable(true);
		getHighlights().setWhisperingArrow(BHighlights.H_RIGHT,
				BHighlights.A_RIGHT+10,
				BHighlights.A_CENTER, "right");
		getHighlights().setWhisperingArrow(BHighlights.H_LEFT,
				BHighlights.A_LEFT-10,  
				BHighlights.A_CENTER, "left");
		getHighlights().setWhisperingArrow(BHighlights.H_UP,
				 BHighlights.A_CENTER, 
				 BHighlights.A_TOP-10, "up");
		getHighlights().setWhisperingArrow(BHighlights.H_DOWN,
				 BHighlights.A_CENTER, 
				 BHighlights.A_BOTTOM+10, "down");
	}

	public Object getForm() {
		return form;
	}

	public String getName() {
		return name;
	}
	
	@Override
	public boolean handleEvent(HmeEvent event) {
		if(event instanceof BEvent.Focus) {
			// any focus change means we reset activation
			activated = false;
		}
		// TODO Auto-generated method stub
		return super.handleEvent(event);
	}
	
	@Override
	public boolean handleKeyRepeat(int code, long rawcode) {
		if(code >= TyPo.KEY_ASCII_START && code <= TyPo.KEY_ASCII_END) {
			char c = (char) (code - TyPo.KEY_ASCII_OFFSET);
			typed(String.valueOf(c));
			return true;
		}
		switch(code) {
		case KEY_REVERSE:
		case TyPo.KEY_BACKSPACE:
			return handleKeyPress(code, rawcode);
        case KEY_UNKNOWN:
			if (!((WebBrowserApp) getBApp()).isSlideRemoteSupported()) {
				return handleKeyboard(rawcode);
			}
			break;
		}
		return super.handleKeyRepeat(code, rawcode);
	}
	
	private boolean handleKeyboard(long rawcode) {
		String typed = TyPo.getKeyboardString(rawcode);
		typed = typed.toLowerCase();
		return typed(typed);
	}
	
	private boolean typed(String typed) {
		if(typed != null) {
			activated = true;
			String newVal = addText(typed);
			if (newVal != null) {
				play("updown.snd");
				return true;
			}
		}
		return false;
	}

	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if(action != null && ((HTMLFormField)action).disabled) {
			return super.handleKeyPress(code, rawcode);
		}
		if(code >= TyPo.KEY_ASCII_START && code <= TyPo.KEY_ASCII_END) {
			char c = (char) (code - TyPo.KEY_ASCII_OFFSET);
			if(typed(String.valueOf(c))) {
				return true;
			} else {
				play("bonk.snd");
				return true;
			}
		}
//TODO handle thumbsup/down as shift/capslock change for keyboard?? or no, that is a V49 feature from our perspective.
		switch (code) {
		case KEY_SELECT: 
		{
			activated = true;
			postEvent(new BEvent.Action(this, getAction()));
			return true;
		}
		// handle basic number entry
		case KEY_NUM0:
		case KEY_NUM1:
		case KEY_NUM2:
		case KEY_NUM3:
		case KEY_NUM4:
		case KEY_NUM5:
		case KEY_NUM6:
		case KEY_NUM7:
		case KEY_NUM8:
		case KEY_NUM9:
		{
			activated = true;
			String ch = String.valueOf((char)('0'+(code-KEY_NUM0)));
			String newVal = addText(ch);
			if (newVal != null) {
				play("updown.snd");
				return true;
			}
		}
		break;
		case KEY_RECORD:
		{
			activated = true;
			String ch = ".";
			String newVal = addText(ch);
			if (newVal != null) {
				play("updown.snd");
				return true;
			}
		}
		break;
		case KEY_ADVANCE:
		{
			activated = true;
			String ch = "-";
			String newVal = addText(ch);
			if (newVal != null) {
				play("updown.snd");
				return true;
			}
		}
		break;
		case KEY_REPLAY:
		{
			activated = true;
			String ch = ",";
			String newVal = addText(ch);
			if (newVal != null) {
				play("updown.snd");
				return true;
			}
		}
		break;
		case KEY_FORWARD:
		{
			activated = true;
			String ch = " ";
			String newVal = addText(ch);
			if (newVal != null) {
				play("updown.snd");
				return true;
			}
		}
		break;
		case KEY_CLEAR:
		{
			//TODO allow "undo" by hitting it again
			activated = true;
			String newVal = clearText();
			if (newVal != null) {
				play("thumbsdown.snd");
				return true;
			}
		}
		break;
		case TyPo.KEY_BACKSPACE:
		case KEY_REVERSE:
		{
			if(activated) {
				String newVal = backspaceText();
				if (newVal != null) {
					play("deselect.snd");
					return true;
				}
				// don't ever do default ("back") behavior, that's be weird.
				return true;
			}
		}
//		break;
		default: {
			return super.handleKeyPress(code, rawcode);
		}
		}
		return false;
	}
	
    public boolean handleKeyRelease(int code, long rawcode) {
        switch(code) {
        case KEY_UNKNOWN:
			if (!((WebBrowserApp) getBApp()).isSlideRemoteSupported()) {
				return handleKeyboard(rawcode);
			}
        	break;
        }
        return false;
    }
	
	private String addText(String ch) {
		if (action instanceof HTMLFormInput) {
			HTMLFormInput htmlText = (HTMLFormInput) action;
			String value = htmlText.getAttribute("value");
			if(value == null) value = "";
			value += ch;
			htmlText.putAttribute("value", value);
			updateText(htmlText.type, value, htmlText.color,
					htmlText.getFontString(getFontScale()));
			return value;
		} else if (action instanceof HTMLFormTextarea) {
			HTMLFormTextarea htmlText = (HTMLFormTextarea) action;
			String value = htmlText.contents;
			if(value == null) value = "";
			value += ch;
			htmlText.contents = value;
			updateText(htmlText.type, value, htmlText.color,
					htmlText.getFontString(getFontScale()));
			return value;
		}
		return null;
	}
	
	private String backspaceText() {
		if (action instanceof HTMLFormInput) {
			HTMLFormInput htmlText = (HTMLFormInput) action;
			String value = htmlText.getAttribute("value");
			if(value != null && value.length() > 0) {
				value = value.substring(0, value.length()-1);
			} else {
				return null;
			}
			htmlText.putAttribute("value", value);
			updateText(htmlText.type, value, htmlText.color,
					htmlText.getFontString(getFontScale()));
			return value;
		} else if (action instanceof HTMLFormTextarea) {
			HTMLFormTextarea htmlText = (HTMLFormTextarea) action;
			String value = htmlText.contents;
			if(value != null && value.length() > 0) {
				value = value.substring(0, value.length()-1);
			} else {
				return null;
			}
			htmlText.contents = value;
			updateText(htmlText.type, value, htmlText.color,
					htmlText.getFontString(getFontScale()));
			return value;
		} 
		return null;
	}
	private String clearText() {
		if (action instanceof HTMLFormInput) {
			HTMLFormInput htmlText = (HTMLFormInput) action;
			String value;// = htmlText.getAttribute("value");
			value = "";
			htmlText.putAttribute("value", value);
			updateText(htmlText.type, value, htmlText.color,
					htmlText.getFontString(getFontScale()));
			return value;
		} else if (action instanceof HTMLFormTextarea) {
			HTMLFormTextarea htmlText = (HTMLFormTextarea) action;
			String value;// = htmlText.contents;
			value = "";
			htmlText.contents = value;
			updateText(htmlText.type, value, htmlText.color,
					htmlText.getFontString(getFontScale()));
			return value;
		}
		return null;
	}

	private float getFontScale() {
		return ((WebBrowserApp)getBApp()).getFontScale();
	}

	private Object getAction() {
		return this.action;
	}
	
	public void setAction(Object action) {
		this.action = action;
	}
	
}
