package com.blackledge.david.html.hme;

import java.awt.Color;
import java.awt.Rectangle;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.lang.ref.WeakReference;
import java.net.CookieHandler;
import java.net.CookieManager;
import java.net.CookieStore;
import java.net.HttpCookie;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.net.UnknownHostException;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.jsoup.Connection;
import org.jsoup.Connection.Method;
import org.jsoup.Connection.Response;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import com.almilli.tivo.bananas.hd.CustomSkin;

import com.blackledge.david.html.hme.WebBrowserApp.MEDIA;
import com.blackledge.david.tivo.widgets.PleaseWaitView;
import com.blackledge.david.tivo.widgets.typo.TyPo;
import com.blackledge.david.tivo.widgets.typo.TyPoScreen;
import com.blackledge.david.tivo.widgets.typo.WordList;
import com.blackledge.david.tivo.widgets.typo.TyPo.Keyboard;

import com.tivo.core.ds.TeDict;
import com.tivo.hme.bananas.BApplication;
import com.tivo.hme.bananas.BHighlight;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.interfaces.IContext;
import com.tivo.hme.interfaces.IHmeConstants;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.HmeEvent.DeviceInfo;
import com.tivo.hme.sdk.HmeEvent.FontInfo;
import com.tivo.hme.sdk.IHmeProtocol;
import com.tivo.hme.sdk.Resource;
import com.tivo.hme.sdk.StreamResource;
import com.tivo.hme.sdk.Version;
import com.tivo.hme.sdk.View;

/**
 * <h1>"Enter Webz" - the first ever Web Browser for the TiVo DVR.</h1> <h2>
 * THUMB tacks page controls</h2>
 * <TABLE border=1>
 * <TR>
 * <TH>Thumbs Up</TH>
 * <TD>for "Last Visited" or "(temp)" entries, saves as a THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>Thumbs Down OR clear</TH>
 * <TD>Delete THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>enter OR info</TH>
 * <TD>Edit Title</TD>
 * </TR>
 * <TR>
 * <TH>Select OR right OR FF</TH>
 * <TD>Load Link or App</TD>
 * </TR>
 * <TR>
 * <TH>left or RW</TH>
 * <TD>Back. If this is the starting page, quits the app.</TD>
 * </TR>
 * <TR>
 * <TH>Pause</TH>
 * <TD>Quit App</TD>
 * </TR>
 * </TABLE>
 * <h2>Web page controls</h2>
 * <TABLE border=1>
 * <TR>
 * <TH>Thumbs Up</TH>
 * <TD>THUMB tack page (saves session cookies, too)</TD>
 * </TR>
 * <TR>
 * <TH>Thumbs Down</TH>
 * <TD>remove THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>Play</TH>
 * <TD>Open THUMBS tacks page</TD>
 * </TR>
 * <TR>
 * <TH>RW</TH>
 * <TD>Back. If this is the starting page, quits the app.</TD>
 * </TR>
 * <TR>
 * <TH>1-9</TH>
 * <TD>Change font size</TD>
 * </TR>
 * <TR>
 * <TH>0</TH>
 * <TD>reset to default font size</TD>
 * </TR>
 * <TR>
 * <TH>ASPECT</TH>
 * <TD>change "brightness"</TD>
 * </TR>
 * <TR>
 * <TH>ENTER</TH>
 * <TD>turn off/on table layout (looks better, but takes time & memory and some
 * things end up off screen)</TD>
 * </TR>
 * <TR>
 * <TH>left/right</TH>
 * <TD>select link or form field</TD>
 * </TR>
 * <TR>
 * <TH>up/down</TH>
 * <TD>select link or form field, scroll up/down at edge</TD>
 * </TR>
 * <TR>
 * <TH>channel up/down</TH>
 * <TD>scroll a page up/down</TD>
 * </TR>
 * <TR>
 * <TH>Pause</TH>
 * <TD>Quit App</TD>
 * </TR>
 * <TR>
 * <TH><a href="#">link</a>: Select OR FF</TH>
 * <TD>Load Link</TD>
 * </TR>
 * <TR>
 * <TH><input type="submit" value="submit button">/img button/<button>html
 * button</button>: Select</TH>
 * <TD>Submit form</TD>
 * </TR>
 * <TR>
 * <TH><select><option>select field</option><option>option 2</option></select>:
 * Select</TH>
 * <TD>Open selections list</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): Select OR right</TH>
 * <TD>select entry</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): up/down ; channel up/down ; ADV</TH>
 * <TD>navigate list (single, page, ends)</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): anything else</TH>
 * <TD>cancel selection</TD>
 * </TR>
 * <TR>
 * <TH><input type="checkbox" checked>/<input type="radio" checked>(check/radio
 * field): Select</TH>
 * <TD>check/uncheck field</TD>
 * </TR>
 * <TR>
 * <TH><input type="text" size=4 value="text">/<textarea rows=2
 * cols=8>textarea</textarea>: Select</TH>
 * <TD>Open keyboard</TD>
 * </TR>
 * <TR>
 * <TH>(text field): 0-9</TH>
 * <TD>type a number</TD>
 * </TR>
 * <TR>
 * <TH>(text field): REC</TH>
 * <TD>type a period (".")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): ADV</TH>
 * <TD>type a dash ("-")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): REPLAY</TH>
 * <TD>type a comma (",")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): FF</TH>
 * <TD>type a space</TD>
 * </TR>
 * <TR>
 * <TH>(text field): RW</TH>
 * <TD>delete last character</TD>
 * </TR>
 * <TR>
 * <TH>(text field): CLEAR</TH>
 * <TD>clear field</TD>
 * </TR>
 * </TABLE>
 * <h2>TiVo App (hme://) URLs</h2> Enter Webz supports custom urls of the form
 * <code>hme://hostname:port/path</code> to launch other TiVo Apps.<BR>
 * <var>hostname</var> can be an ip address or a registered domain name that
 * points to the IP address. It processes the URL like this:
 * <OL>
 * <LI>translate the <var>hostname</var> to an <var>ip-address</var>
 * <LI>try to get the TiVoConnect xml file at
 * <code>http://<var>ip-address</var>/TiVoConnect</code>
 * <LI>Check the TiVoConnect file for an hme App entry whose URL has a path that
 * starts with <var>path</var>, and transition to that App
 * <LI>If no app matches, or if there was no TiVoConnect file, attempt to
 * transition to the app at <code>http://<var>ip-address</var>:port/path</code>
 * </OL>
 * <h2>Media URLs</h2> Links that go directly to something other than a text or
 * web page are treated as media URLs. They are passed to the TiVo in hopes that
 * it can handle them. <h3>Pictures</h3> Supported formats are PNG, GIF
 * (including animated GIF), and JPEG.<BR>
 * Use RW or LEFT to return to the previous page. <h3>Music and Audio Files</h3>
 * Supported format is MP3.<BR>
 * Use RW or LEFT to return to the previous page and end the audio.<BR>
 * Use Pause and Play to stop and restart the audio. <h3>Video (TiVos Series 3
 * and later only)</h3> Supported formats are: MPEG, MPEG1, MPEG2, MPEG4 (h.264,
 * and 512KB or higher).<BR>
 * Use LEFT to return to the previous page and end the video.<BR>
 * Use Pause and Play to stop and restart the video.<BR>
 * Use RW and FF to adjust the Rewind and FastForward speed of the video.<BR>
 * If the video reaches the end of the in-progress download, you'll get a
 * "BUFFER END" message. Wait a moment for more to download, then press play
 * again.
 * 
 * @author David Blackledge
 * 
 */
public class WebBrowserApp extends BApplication {
	public static final float PIP_SCALE = 2f/7f; // I measured Premiere's pip as > 2/7ths, <.3 by width

	static {
		// add support for the "hme:" protocol in URLs
		System.setProperty("java.protocol.handler.pkgs", //$NON-NLS-1$
				"com.blackledge.david.html"); //$NON-NLS-1$
		// turn on automatic cookie handling
		// TODO have to use a custom CookieStore that loads/stores cookies per
		// TiVo simultaneous
		CookieHandler.setDefault(new CookieManager());
	}

	/**
	 * just expose the AppFactory where the default server expects to find it.
	 */
	public static class WebBrowserAppFactory extends com.blackledge.david.html.hme.WebBrowserAppFactory {
	}

	/**
	 * params TeDict key used in transitionBack call when browser closes. Value
	 * is the String URL of the page displayed at that time.
	 */
	public static final String WEBPAGE_URL = "WEBPAGE_URL"; //$NON-NLS-1$
	/**
	 * params TeDict key used in transitionBack call when browser closes. Value
	 * is the String URL of the icon for the page displayed at that time.
	 */
	public static final String WEBPAGE_TITLE = "WEBPAGE_TITLE"; //$NON-NLS-1$
	public static final String WEBPAGE_ICON = "WEBPAGE_ICON"; //$NON-NLS-1$
	// attributes: {
	// Cookie=id=5d7aa013befaf038e20e7b6873aca31cce0de228,
	// Host=192.168.0.20:7288,
	// User-Agent=TvHttpClient,
	// Connection=close,
	// tsn=65...C5
	// }
	// LOG: event 1.DEVICE_INFO(com.tivo.core.ds.MapThreadWrapper@184554050{
	// com.tivo.examine.idType.stationId=tivo,
	// platform=Gen06,
	// host=Bedroom,
	// brand=TiVo,
	// com.tivo.examine.showing=true,
	// com.tivo.examine.idType.contentId=tivo,
	// version=11.0k-01-2-652
	// })
	// LOG: event
	// 1.RESOLUTION_INFO(640x480-PAR=1/1,avail=[704x480-PAR=40/33,640x480-PAR=1/1,1280x720-PAR=1/1])
	// FIXME new bananas: set maxStackSize for auto-remove of old non-first
	// screens, calls "remove()" (vs. handleExit) (sets numScreensRemoved)
	static final String BROWSER_NAME = Messages.getString("WebBrowserApp.BROWSER_NAME"); //$NON-NLS-1$
	static final String BROWSER_VERSION = Messages.getString("WebBrowserApp.BROWSER_VERSION"); //$NON-NLS-1$
	static final String NOTICE = MessageFormat.format(Messages.getString("WebBrowserApp.NOTICE"),BROWSER_NAME) ; //$NON-NLS-1$

	/** the title presented to the TiVo */
	public static final String TITLE = BROWSER_NAME;
	/** the URI path used by the TiVo to access this application */
	public static final String URI = "webz"; //$NON-NLS-1$

	private static final String BOOKMARK_ENTRY_SEP = "\n"; //$NON-NLS-1$
	private static final String BOOKMARK_URL_TITLE_SEP = "\t"; //$NON-NLS-1$
	private static final String BOOKMARKS_KEY = "BOOKMARKS"; //$NON-NLS-1$
	private static final String LAST_URL_KEY = "LAST_URL"; //$NON-NLS-1$
	private static final String LAST_TITLE_KEY = "LAST_TITLE"; //$NON-NLS-1$
	private static final String OPTIONS_KEY = "OPTIONS"; //$NON-NLS-1$


	public static final String STREAM_LIVETV = "livetv:"; //$NON-NLS-1$
	public static final String STREAM_LOOP_RED_CENTRAL = "loopset:Central"; //$NON-NLS-1$
	public static final String STREAM_LOOP_PURPLE_SHOWCASES = "loopset:Showcases"; //$NON-NLS-1$
	public static final String STREAM_LOOP_BLUE_SETUP = "loopset:Setup"; //$NON-NLS-1$
	public static final String STREAM_LOOP_GREEN_NOWPLAYING = "loopset:NowPlaying"; //$NON-NLS-1$
	public static final String STREAM_RECORDING_PREFIX = "recording:"; //$NON-NLS-1$
	
	private static final String METHOD_POST = "POST"; //$NON-NLS-1$
	private static final String METHOD_GET = "GET"; //$NON-NLS-1$

	/** Jsoup default is 3 seconds. not long enough for our purposes */
	private static final int CONNECTION_TIMEOUT = 15 * 1000;

	private static final String HTTP_HEADER_USER_AGENT = "User-Agent"; //$NON-NLS-1$
	private static final String HTTP_HEADER_COOKIE = "Cookie"; //$NON-NLS-1$
	private static final String HTTP_HEADER_SET_COOKIE = "Set-Cookie"; //$NON-NLS-1$
	/**
	 * If the field value is a relative URI, it SHOULD be interpreted relative
	 * to the Request-URI. The URI MUST NOT include a fragment.
	 */
	private static final String HTTP_HEADER_REFERER = "Referer"; //$NON-NLS-1$
	/**
	 * For 201 (Created) responses, the Location is that of the new resource
	 * which was created by the request. For 3xx responses, the location SHOULD
	 * indicate the server's preferred URI for automatic redirection to the
	 * resource. The field value consists of a single absolute URI.
	 */
	private static final String HTTP_HEADER_LOCATION = "Location"; //$NON-NLS-1$
	/** sent with 401 (Unauthorized) to define what is needed */
	private static final String HTTP_HEADER_WWW_AUTHENTICATE = "WWW-Authenticate"; //$NON-NLS-1$
	/** usually in response to a 401 */
	private static final String HTTP_HEADER_AUTHORIZATION = "Authorization"; //$NON-NLS-1$
	private static final byte[] MEMENTO_BOOKMARKS = "BOOKMARKS".getBytes(); //$NON-NLS-1$
	private static final byte[] MEMENTO_QUIT_ON_RETURN = "QUIT_ON_RETURN".getBytes(); //$NON-NLS-1$

	/** URL string arg when browser is launched */
	String startURL;
	/** whether bookmarks are allowed */
	private boolean disableBookmarks = false;
	/** current scale to use when rendering fonts */
	private float fontScale = 1.0f;
	/** Whether User-Agent includes AvantGo so websites think we're mobile */
	private boolean appearMobile = true;
	/**
	 * Whether to apply Table Layout code (otherwise, table cells are treated as
	 * individual lines)
	 */
	private boolean layoutTables = true;

	private CustomSkin hdSkin;

	private BView pleaseWait;
	private TyPoScreen typoScreen;
	// private TyPo typo;
	private boolean showTV = false;
	private BView pipView;
	private boolean maximizedDisplay = false;

	public static void debugOut(Object output) {
		if(getDebugLevel() > 0)
			System.out.println(output);
	}
	
	private static Integer debuglevel;
	public static int getDebugLevel() {
		if(debuglevel == null) {
			debuglevel = Integer.getInteger("com.tivo.hme.sdk.debug.level", 0);
		}
		return debuglevel;
	}

	/**
	 * whether or not we want to try and lay out tables
	 * 
	 * @return
	 */
	boolean isLayingOutTables() {
		return layoutTables;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setLayingOutTables(boolean b) {
		this.layoutTables = b;

		saveOptions();
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setAppearingMobile(boolean b) {
		this.appearMobile = b;

		saveOptions();
	}
	
	boolean isAppearingMobile() {
		return this.appearMobile;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setMaximized(boolean b) {
		this.maximizedDisplay = b;
		// adjust the shared displays
		if (maximizedDisplay) {
			if (this.pleaseWait != null && this.pleaseWait.getChildCount() == 1) {
				View child = this.pleaseWait.getChild(0);
				child.setLocation(child.getX(), 0);
			}
		} else {
			if (this.pleaseWait != null && this.pleaseWait.getChildCount() == 1) {
				View child = this.pleaseWait.getChild(0);
				child.setLocation(child.getX(), getSafeTitleVertical());
			}
		}

		saveOptions();
	}
	
	boolean isMaximized() {
		return this.maximizedDisplay;
	}

	public Response followRedirects(Response resp, String referer) throws IOException {
		return followRedirects(resp, 1, referer);
	}

	public Response followRedirects(Response resp, int count, String referer)
			throws IOException {
		int status = resp.statusCode();
		boolean needsRedirect = false;
		if (status != HttpURLConnection.HTTP_OK) {
			if (status == HttpURLConnection.HTTP_MOVED_TEMP
					|| status == HttpURLConnection.HTTP_MOVED_PERM
					|| status == HttpURLConnection.HTTP_SEE_OTHER)
				needsRedirect = true;
		}
		if (!needsRedirect)
			return resp;
		if (count > 15) {
			throw new IOException(MessageFormat.format(
					Messages.getString("WebBrowserApp.too_many_redirects_exception"), //$NON-NLS-1$
					resp.url(), resp.header(HTTP_HEADER_LOCATION)));
		}
		// debugOut(String.format("REDIRECT %d URL %s -> %s", count, resp.url(),
		// resp.header(HTTP_HEADER_LOCATION)));
		debugOut("REDIRECT " + count + " URL " + resp.url() + "-->" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				+ resp.header(HTTP_HEADER_LOCATION));

		URL redirectUrl = new URL(resp.url(), resp.header(HTTP_HEADER_LOCATION));
		Connection con = Jsoupconnect(redirectUrl.toString())
				// always redirect with a get. any data param from original req are
				// dropped.
				.followRedirects(false).method(Method.GET) 
				;
		if(referer != null) {
			// not in spec, but general consensus is to maintain referer on redirects
			con.referrer(referer);
		}
		Response res = con.execute();
			

		return followRedirects(res, count + 1, referer);
	}

	private String getUserAgent() {
		String tivo = "TiVo"; //$NON-NLS-1$
		if (tivoVersion != null) {
			tivo += "/" + tivoVersion; //$NON-NLS-1$
		}
		String browser = BROWSER_NAME + "/" + BROWSER_VERSION; //$NON-NLS-1$
		String userAgent = "Mozilla/5.0 (compatible; " + browser + "; " + tivo //$NON-NLS-1$ //$NON-NLS-2$
				+ ")"; //$NON-NLS-1$
		if (appearMobile) {
			userAgent = "Mozilla/5.0 (compatible; AvantGo 3.2; compatible; " //$NON-NLS-1$
					+ browser + "; " + tivo + ") Mobile"; //$NON-NLS-1$ //$NON-NLS-2$
		}
		return userAgent;
	}

	// HME 1.4.1e
	private boolean setPreferredResolution() {
		/* BEGIN HME 1.4.1e only */
		if (isResolutionSupported()) {
			boolean noChangeNeeded = this
					.getReceiverResolutionInfo()
					.getPreferredRenderingResolution()
					.equals(this.getReceiverResolutionInfo()
							.getRenderingResolution());
			if (noChangeNeeded) {
//				debugOut(this.getCurrentResolution()+" is already preferred resolution of "+this.getReceiverResolutionInfo().getAvailableRenderingResolutions());
				return false;
			} else {
//				 debugOut(this.getCurrentResolution()
//						 +" => "+this.getReceiverResolutionInfo().getPreferredRenderingResolution()+" of "+this.getReceiverResolutionInfo().getAvailableRenderingResolutions());
				this.setReceiverResolution(this.getReceiverResolutionInfo()
						.getPreferredRenderingResolution());
				return true;
			}
		}
		/* END HME 1.4.1e only */
		return false;
	}

	// /HME 1.4.1e

	@Override
	public void init(IContext context) throws Exception {
		super.init(context);

		loadOptions();

		// setSkin(new BResSkin(this, "com/tivo/hme/bananas/images720/"));
		// setSkin(new BResSkin(this, "com/almilli/tivo/bananas/hd/images/"));
		hdSkin = new CustomSkin(this);
		// boolean highDef = getHeight() > 480;
		// if (highDef) {
		// String prefix =
		// HDApplication.class.getPackage().getName().replace('.', '/') +
		// "/images/";
		String prefix = "com/almilli/tivo/bananas/hd/images/"; //$NON-NLS-1$

		// add the highlight bar
		Properties props = new Properties();
		props.put("cap", "50"); //$NON-NLS-1$ //$NON-NLS-2$
		props.put("padh", "25"); //$NON-NLS-1$ //$NON-NLS-2$
		props.put("padv", "4"); //$NON-NLS-1$ //$NON-NLS-2$
		hdSkin.add(BHighlight.H_BAR
				, 1280, 60, prefix + "bar_hd.png", props); //$NON-NLS-1$

		// add the keyboard highlight
		hdSkin.add(BHighlight.H_KEYBOARD
				, 144, 100, prefix + "keyboard-focus.png"); //$NON-NLS-1$

		// add the arrows
		hdSkin.add(BHighlight.H_UP
				, 48, 40, prefix + "up_hd.png"); //$NON-NLS-1$
		hdSkin.add(BHighlight.H_DOWN
				, 48, 40, prefix + "down_hd.png"); //$NON-NLS-1$
		hdSkin.add(BHighlight.H_LEFT
				, 35, 30, prefix + "left_hd.png"); //$NON-NLS-1$
		hdSkin.add(BHighlight.H_RIGHT
				, 35, 30, prefix + "right_hd.png"); //$NON-NLS-1$
		// }

		flush();
		// showFirstPage();

		if (isSDK141()) {
			// TODO probably too low, but might help the memory issues.
			setMaxStackDepth(10);
		}

		// WordList currently requires you call load before you can call
		// addWord.
		WordList wordList = WordList.getInstance();
		wordList.addWord("com/"); //$NON-NLS-1$
		wordList.addWord("org/"); //$NON-NLS-1$
		wordList.addWord("net/"); //$NON-NLS-1$
		wordList.addWord("google.com/"); //$NON-NLS-1$
		wordList.addWord("yahoo.com/"); //$NON-NLS-1$
		wordList.addWord("aol.com"); //$NON-NLS-1$
		wordList.addWord("gmail.com"); //$NON-NLS-1$
		wordList.addWord("html"); //$NON-NLS-1$
		wordList.addWord("http://"); //$NON-NLS-1$
		wordList.addWord("https://"); //$NON-NLS-1$
		wordList.addWord("www."); //$NON-NLS-1$
		// add bookmarks hosts, too.
		java.util.LinkedHashMap<String, URL[]> bookmarks = getBookmarks();
		if (bookmarks != null)
			for (URL[] url : bookmarks.values()) {
				wordList.addWord(url[0].getHost());
			}

		waitingToInit = true;
		boolean changed = setPreferredResolution();
		// will continue init on rootBoundsChanged()

		this.setActive(true);

		if (!changed || !isResolutionSupported()) {
			waitingToInit = false;
			showFirstPage();
		}

	}

	private void showFirstPage() {
		debugOut("firstPage - startURL: " + startURL); //$NON-NLS-1$
		
		if (showTV) {
			setUpLiveTV();
		}
		
		if (startURL != null) {
			showPleaseWait();
			try {
				URL url = new URL(startURL);
				if (url.getProtocol().toLowerCase().startsWith("hme")) { //$NON-NLS-1$
					debugOut("LOAD APP on init " + url); //$NON-NLS-1$
					this.loadApp(url);
				} else {
					debugOut("LOAD url on init " + url); //$NON-NLS-1$
					WebScreen webScreen = WebScreen.newWebScreen(this);
					boolean pageSuccess = webScreen.prepare(url);
					if (!pageSuccess) {
						hidePleaseWait();
						play("bonk.snd"); //$NON-NLS-1$
						webScreen.remove();
						showBookmarks(true);
					} else {
						push(webScreen, TRANSITION_FORWARD, url);
					}
				}
			} catch (MalformedURLException ex) {
				showBookmarks(true);
			}
		} else {
			showBookmarks(true);
		}

	}

	private void setUpLiveTV() {
		// int pipWidth = 150;
		// int pipHeight = (int)
		// (((float)getAbove().getHeight())*(pipWidth/((float)getAbove().getWidth())));
		// float pipScale = ((float)pipWidth)/((float)getAbove().getWidth());
		float pipScale = PIP_SCALE;
		int pipWidth = (int) (getAbove().getWidth() * pipScale);
		int pipHeight = (int) (getAbove().getHeight() * pipScale);
		// debugOut("PIP SCALE:"+pipScale);
		// juse use height/width to position the view. Size is reduced by the
		// scale factor
		pipView = new BView(getAbove(), getAbove().getWidth()-pipWidth, 0,
				getAbove().getWidth(), getAbove().getHeight(),
				// pipWidth, pipHeight,
				true);
		pipView.setScale(pipScale, pipScale);
		flush(); // try to ensure scale isn't ignored (race condition?) (didn't
					// help, but works now...go figure)
		pipView.setResource(pipView.createStream(STREAM_LIVETV));
		// showLiveTV();
	}

	public boolean isShowingLiveTV() {
		return showTV;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setShowLiveTV(boolean showTV) {
		this.showTV = showTV;
		hideLiveTV();
		showLiveTV();

		saveOptions();
	}

	public void showLiveTV() {
		if (showTV && pipView != null) {
			pipView.setScale(PIP_SCALE, PIP_SCALE); // FIXME hack? sometimes it isn't
											// sized right... I think it's a
											// race condition
			flush();
			if (!pipView.getVisible()) {
				pipView.setResource(pipView.createStream(STREAM_LIVETV));
				pipView.setVisible(true);
				flush();
			}
		}
	}

	public void backgroundLiveTV() {
		if (pipView != null) {
			pipView.setVisible(false);
		}
	}

	public void hideLiveTV() {
		if (pipView != null) {
			pipView.setVisible(false);
			if (pipView.getResource() != null)
				pipView.getResource().remove();
			pipView.clearResource();
			flush();
			// pipView.setResource(pipView.createStream(STREAM_LIVETV));
		}
	}
	
	public boolean pauseLiveTV() {
		if (pipView != null && pipView.getResource() != null
				&& pipView.getResource() instanceof StreamResource) {
			((StreamResource) pipView.getResource()).pause();
			return true;
		}
		return false;
	}

	/**
	 * Check this variable during handleExit to find out of the exit is
	 * happening due to a "pop" (leaving this Screen permanently) instead of due
	 * to a "push" (going to a new Screen, will return to this one eventually).
	 */
	public boolean isPopping = false;

	@Override
	public void pop(Object arg) {
		isPopping = true;
		BScreen popped = getCurrentScreen();
		super.pop(arg);
		if (popped != this.typoScreen) {
			// do what removeOldScreens does
			popped.setVisible(false);
			popped.remove();
		}
		isPopping = false;
	}

	/* BEGIN END NEXT LINE HME 1.4.1e only */
	// @Override
	public void replaceCurrentScreen(BScreen newScreen, int transition,
			Object arg) {
		BScreen popped = getCurrentScreen();
		// super.replaceCurrentScreen(newScreen, transition, arg);
		super.pop();
		super.push(newScreen, transition, arg);

		// FIXME removed this for now... causing problems...why???
		// // do what removeOldScreens does
		// popped.setVisible(false);
		// popped.remove();
	}

	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if (!super.handleKeyPress(code, rawcode)) {
			switch (code) {
			case KEY_CLEAR:
				closeBrowser();
				return true;
			case KEY_PLAY:
				if (!isBookmarksDisabled()
						&& getCurrentScreen() instanceof WebScreen) {
					showBookmarks();
					return true;
				}
				break;
			case KEY_PAUSE:
				if(isShowingLiveTV() && pauseLiveTV()) {
					return true;
				}
				//TODO not sure we want to do this still
				closeBrowser();
				return false;
			case KEY_SLOW:
				setShowLiveTV(!isShowingLiveTV());
				return true;
			}
			return false;
		}
		return true;
	}

	public void closeBrowser() {
		// make sure all bookmarks have their latest cookies
		refreshBookmarks();
		
		// return something useful about the current browser state
		// mainly for use with Google Auth stuff, but also useful for restarting
		// where we left off.
		transitionBack(getReturnParams());
		// setActive(false);
	}

	private TeDict getReturnParams() {
		TeDict result = new TeDict();
		// use page they were on, not last visited unless we're not "on" a page.
		if (!(getCurrentScreen() instanceof WebScreen)) {
			URL url = getLastVisited();
			if (url != null) {
				result.add(WEBPAGE_URL, url.toString());
			} else {
				// ok, not even a lastvisited? nothing is worth returning then.
				return null;
			}
			String title = getLastVisitedTitle();
			if (title != null) {
				result.add(WEBPAGE_TITLE, title);
			}
		} else {
			WebScreen screen = (WebScreen) getCurrentScreen();
			if (screen == null)
				return null;
			URL url = screen.getURL();
			if (url != null) {
				result.add(WEBPAGE_URL, url.toString());
			}
			String title = screen.getTitle();
			if (title != null) {
				result.add(WEBPAGE_TITLE, title);
			}
			URL icon = screen.getIconURL();
			if (icon != null) {
				result.add(WEBPAGE_ICON, icon.toString());
			}
		}
		debugOut("RETURNING: " + result); //$NON-NLS-1$
		return result;
	}

	@Override
	public boolean handleKeyRelease(int code, long rawcode) {
		// Handle App Startup key, if so desired
		if (getCurrentScreen() == null) {
			switch (code) {
			case KEY_PLAY:
				debugOut("started with PLAY"); //$NON-NLS-1$
				break;
			case KEY_SELECT:
				debugOut("started with SELECT"); //$NON-NLS-1$
				break;
			case KEY_RIGHT:
				debugOut("started with RIGHT"); //$NON-NLS-1$
				break;
			}
		}
		return super.handleKeyRelease(code, rawcode);
	}

	/**
	 * Load an hme:// url as an app.
	 * 
	 * @param link
	 */
	void loadApp(URL link) {

		// FIXME check out possible alternative "URL" for the apps:
		// at 204.176.49.116
		// Amazon: x-tivo:hme:uuid:35FE011C-3850-2228-FBC5-1B9EDBBE5863
		// Blockbuster: x-tivo:hme:uuid:63ED0C3D-D49C-9602-C322-E0A3D3EA5A3D
		// Browse Web Videos:
		// x-tivo:hme:uuid:19452283-D00B-C411-595D-447ABF62F37C
		// Browse Web Videos:
		// x-tivo:hme:uuid:6784571A-016C-8A46-DF2F-FD842D78006F
		// Fandango: x-tivo:hme:uuid:B9DDBECF-BC6D-5E33-388A-4CF840068D79
		// Music Choice: x-tivo:hme:uuid:7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D
		// Netflix: x-tivo:hme:uuid:7edeb291-0db8-487f-b842-6b97bc71ad9a
		// One True Media: x-tivo:hme:uuid:D1AF7BED-325E-5E6E-B087-72381C92D077
		// Swivel: x-tivo:hme:uuid:2BD40EF7-D9D2-3CD4-0130-6C18855CE898
		// TiVoCast RSS: x-tivo:hme:uuid:863cb78f-efdd-4106-b572-51733983dc76
		// Youtube: x-tivo:hme:uuid:9AA364C9-CF8A-1E1D-B50F-CC65C40D4A96

		// It connects to port 80 and requests a file called TiVoConnect
		// http://209.97.196.52/TiVoConnect
		// which needs to return an xml file (described in the HMO docs I
		// believe)
		// apps.tv creates this on the fly based on the TiVo's ID which is sent
		// in the headers.

		// "lb._dns-sd._udp.0.0.168.192.in-addr.arpa."
		// 204.176.49.116, reverse it for this purpose
		// service+"116.49.176.204"+".in-addr.arpa."
		if (link == null)
			return;

		String loc = null;
		try {
			// 204.176.49.116 main one
			// 204.176.49.123: web page titled
			// "TiVo Premiere: much more than a DVR - TiVo"
			// 208.73.181.192 - no luck... apparently jmdns heartbeat thing
			// "have just noticed a "heartbeat" connection to 208.73.181.192 on port 5223"
			// mdns > 224.0.0.251 // nothing
			// http > 204.176.49.2 // nothing
			// 206.112.115.224,225 (0 entries)
			// 216.235.91.x (Live365) nothing (also with :20000)
			/*
			 * I was able to figure out some ports by examing my firewall log
			 * for dropped messages. I added TCP ports 7287, 7288, and 8000 (to
			 * IPs 204.176.49.x) which got the menu items and their icons to
			 * appear. For Live365 to work, I added ports 20000 through 22000
			 * (to IPs 216.235.91.x).
			 */
			// convert host to IP since that's the way TiVo requests TiVoConnect
			// (and it matters in some cases, like apps.tv)
			String ip;
			try {
				ip = InetAddress.getByName(link.getHost()).getHostAddress();
			} catch (UnknownHostException uhe) {
				// not that it will do any good, but continue with just the host
				// name.
				ip = link.getHost();
			}
			Connection connection = Jsoupconnect("http://" + ip //$NON-NLS-1$
					+ "/TiVoConnect?Command=QueryContainer&Container=%2F&DoGenres=1"); //$NON-NLS-1$
			// from a premiere:
//			/TiVoConnect?Command=QueryContainer&Container=%2F&DoGenres=1
//			/192.168.0.11
//			User-Agent: TmkHttpRequest/1.0
//			Host: 192.168.0.20
//			TiVo_TCD_ID: 746000190AA690F
//			TiVo_SW_VER: 20.2.2.1-01-2			
			// FIXME should do proper redirects with followRedirects and
			// .followRedirects(false)
			String tivoID = this.tivoID;
			String tivoVersion = this.tivoVersion;
			// if(this.tivoVersion == null)
			// // tivoVersion = "7.2.1-oth-01-2";
			// tivoVersion = "11.0c-01-2";

			debugOut("app with tivo headers:" + tivoID + ":" + tivoVersion); //$NON-NLS-1$ //$NON-NLS-2$
			if (tivoID != null)
				connection.header(HTTP_HEADER_TIVO_ID, tivoID);
			if (tivoVersion != null)
				connection.header(HTTP_HEADER_TIVO_VERSION, tivoVersion);
			Document doc = connection.get();
//debugOut(connection.response().headers());
//debugOut(connection.response().body());
			// tivocontainer details
			// contenttype [x-container/tivo-server]
			// sourceformat [x-container/folder]
			// title
			// totalitems [int]

			// tivocontainer itemcount [int]
			// tivocontainer itemstart [int]

			// tivocontainer item
			Elements items = doc.select("tivocontainer item"); //$NON-NLS-1$
			for (Element item : items) {
				// details / contenttype [application/x-hme]
				// details / hidden [present-or-not boolean]
				boolean hidden = (item.select("details hidden").size() > 0); //$NON-NLS-1$
				// details / sourceformat [x-container/folder]
				// details / title
				String title = item.select("details title").text(); //$NON-NLS-1$
				// details / uuid [2BD40EF7-D9D2-3CD4-0130-6C18855CE898]
				String uuid = item.select("details uuid").text(); //$NON-NLS-1$
				// details / x-tivo-topleveldisplayorderhint [int]
				String orderHintText = item.select(
						"details x-tivo-topleveldisplayorderhint").text(); //$NON-NLS-1$
				// links / content / contenttype [application/x-hme]
				// links / content / url
				String contentUrlText = item.select("links content url").text(); //$NON-NLS-1$
				// links / customicon / url
				String iconUrlText = item.select("links customicon url").text(); //$NON-NLS-1$

				debugOut((hidden ? "(hidden)" : "") + title + "[" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
						+ orderHintText + "]" + contentUrlText + " icon: " //$NON-NLS-1$ //$NON-NLS-2$
						+ iconUrlText);

				if (contentUrlText != null
						&& contentUrlText.trim().length() > 0) {
					try {
						URL contentUrl = new URL(contentUrlText);
						debugOut(contentUrl.getPath() + " vs. " //$NON-NLS-1$
								+ link.getPath() + " of " + link); //$NON-NLS-1$
						if (link.getPath().trim().length() > 0) {
							if (contentUrl.getPath().startsWith(link.getPath())) {
								debugOut("matched " + link.getPath()); //$NON-NLS-1$
								loc = contentUrlText;
								break;
							}
						}
					} catch (MalformedURLException ex) {
						// just continue.
					}
//				} else {
//					if (contentUrlText != null) {
//						loc = contentUrlText;
//					}
				}
			}

			// Elements urls =
			// doc.select("tivocontainer item links content url");
			// debugOut(doc.toString());
			// debugOut("urls: "+urls);
			// if(urls != null && urls.size() > 0) {
			// loc = urls.get(0).text().trim();
			// }
			/*
			 * MY TIVO <tivocontainer> <details> <contenttype>
			 * x-container/tivo-server </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Server</title>
			 * <totalitems> 27 </totalitems> </details> <itemcount> 27
			 * </itemcount> <itemstart> 0 </itemstart> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Credit
			 * Card Update (PCI enabled)</title> <uuid>
			 * 984BBCD1-F705-6F3C-8E1A-BA7F4C26B570 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 15
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/CreditCard_20080912-
			 * 20080912_131340/1221250421/1289849840-1605209840/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/CreditCard_20080912
			 * -20080912_131340/1221250421/1289849840-1605209840/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Buy a TiVo
			 * Premiere</title> <uuid> 0F64DC01-096D-D7A9-1145-060E26DD0CE5
			 * </uuid> <x-tivo-topleveldisplayorderhint> 3
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/TivoUpgrade-
			 * 20120424_122953/1335295796/1335399021-1650759021/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/TivoUpgrade
			 * -20120424_122953/1335295796/1335399021-1650759021/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Amazon v1.9
			 * (2010.10.25-0632)</title> <uuid>
			 * 35FE011C-3850-2228-FBC5-1B9EDBBE5863 </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>netflix 1.6</title>
			 * <uuid> 7EDEB291-0DB8-487F-B842-6B97BC71AD9A </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url>
			 * https://204.176.49.65:7287/bundle-netflix-standalone.2011.08
			 * .10-1225-
			 * 20110810_150805/1313014088/1319001823-1634361823/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/bundle
			 * -netflix-standalone.2011.08.10-1225
			 * -20110810_150805/1313014088/1319001823-1634361823/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Order Domino's Pizza
			 * Now</title> <uuid> 6BA2A86B-619B-67A6-BFA3-0E137B167A5A </uuid>
			 * <x-tivo-topleveldisplayorderhint> 21
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176
			 * .49.65:7287/dominos.2009.05.07.r1021.logerror.signed-
			 * 20090507_174812/1241743696/1289849802-1605209802/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/dominos
			 * .2009.05.07.r1021.logerror.signed
			 * -20090507_174812/1241743696/1289849802-1605209802/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Browse and Buy Movie
			 * Tickets</title> <uuid> B9DDBECF-BC6D-5E33-388A-4CF840068D79
			 * </uuid> <x-tivo-topleveldisplayorderhint> 30
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1347427227-1662787227/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1347427227-1662787227/icon_SD.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Photos &amp;
			 * Slideshows</title> <uuid> BBC7824A-40C6-8B61-4D87-6A3D799F365B
			 * </uuid> <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1347904431-1663264431/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1347904431-1663264431/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Search 1.4 Actual
			 * App (2011.03.16-0112)</title> <uuid>
			 * 1D9DF84A-BDF7-421E-B1E9-9BA375C2EF0C </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/hdui-1.4.1.2011.03.16-0112-
			 * 20110316_154124/1300315286/1301509488-1616869488/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hdui-1.4.1.2011.03.16-0112-
			 * 20110316_154124/1300315286/1301509488-1616869488/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Hme Down</title> <uuid>
			 * 9D99EC4B-B08C-191C-3255-40B58B1F5DAF </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/hmedown_20080317-
			 * 20080402_170823/1207181304/1240249987-1587405187/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hmedown_20080317
			 * -20080402_170823/1207181304/1240249987-1587405187/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Guru Guides (3/08 -
			 * 1143)</title> <uuid> 403871C3-A324-21B8-1D8D-826834E758EB </uuid>
			 * </details> <links> <content> <contenttype> application/x-hme
			 * </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849391-1605209391/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849391-1605209391/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>KidZone
			 * (3/8-1143)</title> <uuid> 5D524EE8-B977-1DC8-CD30-39BF60E7749C
			 * </uuid> </details> <links> <content> <contenttype>
			 * application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849349-1605209349/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849349-1605209349/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Search
			 * Beta</title> <uuid> AB306EFD-EB85-47C3-A38E-B29E52DB3C73 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 2
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/launcher-
			 * 1.3_2010.08.06-1858-20100806_190059/1281146460/1282091089-1597451089/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/launcher-
			 * 1.3_2010.08.06-1858-20100806_190059/1281146460/1282091089-1597451089/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Live365</title> <uuid>
			 * 9B26EF4C-BF08-A9A5-F18E-F898DA9ADEB6 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 30
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1347904368-1663264368/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1347904368-1663264368/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Music Videos from Music
			 * Choice</title> <uuid> 7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D
			 * </uuid> <x-tivo-topleveldisplayorderhint> 49
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Rhapsody Music
			 * Service</title> <uuid> AAF73CE2-1AD4-304A-1272-EB8E817238A9
			 * </uuid> <x-tivo-topleveldisplayorderhint> 20
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/norhapsody.2011.08.15-1619-
			 * 20110815_162006/1313450407/1347904314-1663264314/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/norhapsody.2011.08.15-1619-
			 * 20110815_162006/1313450407/1347904314-1663264314/icon_SD.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Pandora</title> <uuid>
			 * 68AD6946-B063-C92F-091B-C3F769FA5B81 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 10
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/pandora-1.1.2011.05.24-1649-
			 * 20110524_165839/1306281520/1347904283-1663264283/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/pandora-1.1.2011.05.24-1649-
			 * 20110524_165839/1306281520/1347904283-1663264283/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Podcaster</title>
			 * <uuid> 6838E9A3-F968-683E-110E-6591066452A1 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 40
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1347904398-1663264398/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1347904398-1663264398/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>SameGame</title> <uuid>
			 * DC47F5CD-C97F-1C8F-EA91-CDDB4CFA1EFA </uuid>
			 * <x-tivo-topleveldisplayorderhint> 65
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01-
			 * 20080402_173700/1207183021/1347427605-1662787605/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01
			 * -20080402_173700/1207183021/1347427605-1662787605/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Skull &amp;
			 * Bones</title> <uuid> 1A73F688-60B2-561D-BBEA-354BB36D3DA4 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 80
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/skullbones_20071012-
			 * 20080402_173743/1207183066/1347427626-1662787626/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/skullbones_20071012
			 * -20080402_173743/1207183066/1347427626-1662787626/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Survey App</title>
			 * <uuid> 5A695917-238E-4218-8066-D4713A314063 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/survey_20080530-
			 * 01_signed-20080530_150815/1212185297/1289848835-1605208835/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/survey_20080530
			 * -01_signed-20080530_150815/1212185297/1289848835-1605208835/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Swivel
			 * 2.8 U.S. Jump Target (03/16/11-0631)</title> <uuid>
			 * 49C791F9-7D48-38AB-8177-9C756D4EE2C0 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Swivel 2.8
			 * (03/16/11-0631)</title> <uuid>
			 * 2BD40EF7-D9D2-3CD4-0130-6C18855CE898 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVoCast 2.8
			 * (2011.03.16-0115)</title> <uuid>
			 * 19452283-D00B-C411-595D-447ABF62F37C </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Video Player</title>
			 * <uuid> 863CB78F-EFDD-4106-B572-51733983DC76 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Wordsmith</title>
			 * <uuid> 41731A91-6B5D-7E7D-C495-9A1F399965C7 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 70
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012-
			 * 20080402_180020/1207184421/1347428154-1662788154/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012
			 * -20080402_180020/1207184421/1347428154-1662788154/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>YouTube</title> <uuid>
			 * 9AA364C9-CF8A-1E1D-B50F-CC65C40D4A96 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 5
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1336773245-1652133245/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1336773245-1652133245/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>YouTube 1.0 (tcast jump
			 * 7/10)</title> <uuid> 06F36A5F-FE5D-4F03-99A0-64B92896B47F </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1282259262-1597619262/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1282259262-1597619262/icon.png </url>
			 * </customicon> </links> </item> </tivocontainer>
			 */

			//
			//
			//

			/*
			 * TIVO: <tivocontainer> <details> <contenttype>
			 * x-container/tivo-server </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Server</title>
			 * <totalitems> 20 </totalitems> </details> <itemcount> 20
			 * </itemcount> <itemstart> 0 </itemstart> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Credit
			 * Card Update (PCI enabled)</title> <uuid>
			 * 984BBCD1-F705-6F3C-8E1A-BA7F4C26B570 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 15
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/CreditCard_20080912-
			 * 20080912_131340/1221250421/1289849840-1605209840/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/CreditCard_20080912
			 * -20080912_131340/1221250421/1289849840-1605209840/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Buy a TiVo
			 * Premiere</title> <uuid> 0F64DC01-096D-D7A9-1145-060E26DD0CE5
			 * </uuid> <x-tivo-topleveldisplayorderhint> 3
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/TivoUpgrade-
			 * 20120424_122953/1335295796/1335399021-1650759021/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/TivoUpgrade
			 * -20120424_122953/1335295796/1335399021-1650759021/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Amazon v1.9
			 * (2010.10.25-0632)</title> <uuid>
			 * 35FE011C-3850-2228-FBC5-1B9EDBBE5863 </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Order Domino's Pizza
			 * Now</title> <uuid> 6BA2A86B-619B-67A6-BFA3-0E137B167A5A </uuid>
			 * <x-tivo-topleveldisplayorderhint> 21
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176
			 * .49.65:7287/dominos.2009.05.07.r1021.logerror.signed-
			 * 20090507_174812/1241743696/1289849802-1605209802/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/dominos
			 * .2009.05.07.r1021.logerror.signed
			 * -20090507_174812/1241743696/1289849802-1605209802/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Browse and Buy Movie
			 * Tickets</title> <uuid> B9DDBECF-BC6D-5E33-388A-4CF840068D79
			 * </uuid> <x-tivo-topleveldisplayorderhint> 30
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1343238702-1658598702/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1343238702-1658598702/icon_SD.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Photos &amp;
			 * Slideshows</title> <uuid> BBC7824A-40C6-8B61-4D87-6A3D799F365B
			 * </uuid> <x-tivo-topleveldisplayorderhint> 47
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1343239081-1658599081/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1343239081-1658599081/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Hme Down</title> <uuid>
			 * 9D99EC4B-B08C-191C-3255-40B58B1F5DAF </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/hmedown_20080317-
			 * 20080402_170823/1207181304/1240249987-1587405187/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hmedown_20080317
			 * -20080402_170823/1207181304/1240249987-1587405187/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Guru Guides (3/08 -
			 * 1143)</title> <uuid> 403871C3-A324-21B8-1D8D-826834E758EB </uuid>
			 * </details> <links> <content> <contenttype> application/x-hme
			 * </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849391-1605209391/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849391-1605209391/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>KidZone
			 * (3/8-1143)</title> <uuid> 5D524EE8-B977-1DC8-CD30-39BF60E7749C
			 * </uuid> </details> <links> <content> <contenttype>
			 * application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849349-1605209349/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849349-1605209349/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Live365</title> <uuid>
			 * 9B26EF4C-BF08-A9A5-F18E-F898DA9ADEB6 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 35
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Music Videos from Music
			 * Choice</title> <uuid> 7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D
			 * </uuid> <x-tivo-topleveldisplayorderhint> 49
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Podcaster</title>
			 * <uuid> 6838E9A3-F968-683E-110E-6591066452A1 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 45
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1343239384-1658599384/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1343239384-1658599384/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>SameGame</title> <uuid>
			 * DC47F5CD-C97F-1C8F-EA91-CDDB4CFA1EFA </uuid>
			 * <x-tivo-topleveldisplayorderhint> 65
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01-
			 * 20080402_173700/1207183021/1343239500-1658599500/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01
			 * -20080402_173700/1207183021/1343239500-1658599500/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Skull &amp;
			 * Bones</title> <uuid> 1A73F688-60B2-561D-BBEA-354BB36D3DA4 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 80
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/skullbones_20071012-
			 * 20080402_173743/1207183066/1343239554-1658599554/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/skullbones_20071012
			 * -20080402_173743/1207183066/1343239554-1658599554/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Survey App</title>
			 * <uuid> 5A695917-238E-4218-8066-D4713A314063 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/survey_20080530-
			 * 01_signed-20080530_150815/1212185297/1289848835-1605208835/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/survey_20080530
			 * -01_signed-20080530_150815/1212185297/1289848835-1605208835/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Swivel
			 * 2.8 U.S. Jump Target (03/16/11-0631)</title> <uuid>
			 * 49C791F9-7D48-38AB-8177-9C756D4EE2C0 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Swivel 2.8
			 * (03/16/11-0631)</title> <uuid>
			 * 2BD40EF7-D9D2-3CD4-0130-6C18855CE898 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVoCast 2.8
			 * (2011.03.16-0115)</title> <uuid>
			 * 19452283-D00B-C411-595D-447ABF62F37C </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Video Player</title>
			 * <uuid> 863CB78F-EFDD-4106-B572-51733983DC76 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Wordsmith</title>
			 * <uuid> 41731A91-6B5D-7E7D-C495-9A1F399965C7 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 70
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012-
			 * 20080402_180020/1207184421/1343239627-1658599627/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012
			 * -20080402_180020/1207184421/1343239627-1658599627/icon.png </url>
			 * </customicon> </links> </item> </tivocontainer>
			 * 
			 * 
			 * 
			 * <!--?xml version="1.0" encoding="ISO-8859-1"?--> <html>
			 * <head></head> <body> <tivocontainer> <details> <contenttype>
			 * x-container/tivo-server </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Server</title>
			 * <totalitems> 0 </totalitems> </details> <itemcount> 0
			 * </itemcount> <itemstart> 0 </itemstart> </tivocontainer> <!--
			 * Copyright (c) 2002-2009 TiVo, Inc. --> </body> </html>
			 */
			/*
			 * <html> <head></head> <body> <tivocontainer> <details>
			 * <contenttype> x-container/tivo-server </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <totalitems> 1
			 * </totalitems> <title>apps.tv HME Server</title> </details>
			 * <itemstart> 0 </itemstart> <itemcount> 1 </itemcount> <item>
			 * <details> <contenttype> application/x-hme </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <title>apps.tv
			 * Subscription Manager</title> </details> <links> <content> <url>
			 * http://209.97.196.52:2281/submanager/ </url> </content> </links>
			 * </item> </tivocontainer> </body> </html>
			 */
			/*
			 * ticketchannel: <html> <head></head> <body> <tivocontainer>
			 * <details> <contenttype> x-container/tivo-server </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <totalitems> 1
			 * </totalitems> <title>Ticket Channel (Beta)</title> </details>
			 * <itemstart> 0 </itemstart> <itemcount> 1 </itemcount> <item>
			 * <details> <contenttype> application/x-hme </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <title>Ticket
			 * Channel (Beta)</title> </details> <links> <content> <url>
			 * http://208.116.35.238:7288/hme/ </url> </content> </links>
			 * </item> </tivocontainer> </body> </html>
			 */
			/*
			 * mp3tunes: <html> <head></head> <body> <tivocontainer> <details>
			 * <contenttype> x-container/tivo-server </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <totalitems> 1
			 * </totalitems> <title>MP3tunes HME Server</title> </details>
			 * <itemstart> 0 </itemstart> <itemcount> 1 </itemcount> <item>
			 * <details> <contenttype> application/x-hme </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <title>MP3tunes
			 * Locker</title> </details> <links> <content> <url>
			 * http://168.143.122.40:7288/mp3tunes/ </url> </content> </links>
			 * </item> </tivocontainer> </body> </html>
			 */
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		URL httplink;
		try {
			httplink = new URL("http" //$NON-NLS-1$
				+ link.toString().substring(link.getProtocol().length()));
		} catch(MalformedURLException e) {
			e.printStackTrace();
			httplink = link;
		}

		if (loc == null) {
			//FIXME support https, too
			loc = httplink.toString();
		} else if (link.getQuery() != null) {
			loc = loc + "?" + link.getQuery(); //$NON-NLS-1$
		}
		
		// handle possible relative URLs
		try {
			loc = new URL(httplink, loc).toString();
		} catch(Exception e) {
			//TODO uh... this is a problem.
			e.printStackTrace();
		}

		TeDict params = null;

		String q = link.getQuery();
		if (q != null) {
			if (q.startsWith("?"))// TODO this should be unnecessary...query //$NON-NLS-1$
									// doesn't include the ?
				q = q.substring(1);
			params = new TeDict();
			String[] nvps = q.split("&"); //$NON-NLS-1$
			for (String nvp : nvps) {
				String[] nameVal = nvp.split("="); //$NON-NLS-1$
				if (nameVal.length == 2) {
					try {
						String name = URLDecoder.decode(nameVal[0], "UTF-8"); //$NON-NLS-1$
						String val = URLDecoder.decode(nameVal[1], "UTF-8"); //$NON-NLS-1$
						params.add(name, val);
					} catch (UnsupportedEncodingException e) {
						e.printStackTrace();
					}
				}
			}
		}
		// if(loc.contains("videoplayer")) {
		// loc += "watch/";
		// }

		play("select.snd"); //$NON-NLS-1$
		byte[] memento;
		if(link.equals(startURL)) {
			// if we're loading an app as our start url, when that app returns,
			// we have to quit... act as a pass-through
			memento = MEMENTO_QUIT_ON_RETURN;
		} else {
			memento = createMemento();
		}
		debugOut("transition to hme app:" + loc + "  " //$NON-NLS-1$ //$NON-NLS-2$
				+ params + " MEMENTO:"+new String(memento)); //$NON-NLS-1$
		this.transitionForward(
				loc, params,
				memento);
	}

	private byte[] createMemento() {
		if(getCurrentScreen() instanceof BookmarkScreen) {
			return MEMENTO_BOOKMARKS;
		}
		URL url = null;
		if(getCurrentScreen() instanceof WebScreen) {
			url = ((WebScreen)getCurrentScreen()).getURL();
		}
		if(url == null) {
			url = getLastVisited();
		}
		if (url != null) {
			return url.toString().getBytes();
		}
		return null;
	}

	private void handleMemento(byte[] memento) {
		if (memento != null && memento.length > 0) {
			if(memento.equals(MEMENTO_QUIT_ON_RETURN)) {
				closeBrowser();
				return;
			} else if(memento.equals(MEMENTO_BOOKMARKS)) {
				// this is the default first page
				return;
			}
			String urlString = new String(memento);
			// try {
			// URL url = new URL(urlString);
			startURL = urlString;
			// } catch (MalformedURLException e) {
			// }
			debugOut("MEMENTO:" + startURL); //$NON-NLS-1$
		}
	}

	private void showBookmarks() {
		showBookmarks(false);
	}

	private void showBookmarks(boolean isFirstPage) {

		BookmarkScreen screen = new BookmarkScreen(this);
		screen.isFirstPage = isFirstPage;
		if (isFirstPage) {
			/* BEGIN HME 1.4.1e only */
			if (isResolutionSupported()) {
				screen.setTargetResolution(this.getReceiverResolutionInfo()
						.getPreferredRenderingResolution());
			}
			/* END HME 1.4.1e only */
		}

		this.push(screen, TRANSITION_FADE);
	}

	public boolean isBookmarksDisabled() {
		return disableBookmarks;
	}

	public boolean saveBookmark(URL urlBase, String titleString, URL icon) {
		if (!isBookmarksDisabled()) {
			String bookmarkString = getContext().getPersistentData(
					BOOKMARKS_KEY);
			if (bookmarkString == null) {
				bookmarkString = ""; //$NON-NLS-1$
			}
			if(bookmarkString.trim().length() == 0) {
				LinkedHashMap<String, URL[]> bookmarks = new LinkedHashMap<String, URL[]>();
				// oh... ok, add all the default bookmarks so they don't lose them.
				try {
					BookmarkScreen.addDefaultWebsiteBookmarks(bookmarks);
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				for(String title : bookmarks.keySet()) {
					URL urls[] = bookmarks.get(title);
					if(urls == null || urls.length < 2)
						continue;
					URL url = urls[0];
					URL iconUrl = urls[1];
					bookmarkString = addBookmark(bookmarkString, url, title, iconUrl);
				}
			}
			bookmarkString = addBookmark(bookmarkString, urlBase, titleString,
					icon);
			getContext().setPersistentData(BOOKMARKS_KEY, bookmarkString);
			return true;
		} else {
			return false;
		}
	}

	private void loadOptions() {
		String optionsString = getContext().getPersistentData(OPTIONS_KEY);
		if (optionsString == null)
			return;
debugOut("LOAD OPTIONS: "+optionsString); //$NON-NLS-1$
		String[] options = optionsString.split(","); //$NON-NLS-1$
		if (options.length > OPTIONS.MOBILE.ordinal())
			this.appearMobile = Boolean.parseBoolean(options[OPTIONS.MOBILE.ordinal()]);
		if (options.length > OPTIONS.SHOW_TV.ordinal())
			this.showTV = Boolean.parseBoolean(options[OPTIONS.SHOW_TV.ordinal()]);
		if (options.length > OPTIONS.MEDIA_STYLE.ordinal() && options[OPTIONS.MEDIA_STYLE.ordinal()].trim().length() > 0)
			this.activeMediaStyle = MEDIA.valueOf(options[OPTIONS.MEDIA_STYLE.ordinal()]);
		 if(options.length > OPTIONS.FONT_SCALE.ordinal())
			 this.fontScale = Float.parseFloat(options[OPTIONS.FONT_SCALE.ordinal()]);
		 if (options.length > OPTIONS.MAXIMIZED.ordinal())
			 this.maximizedDisplay = Boolean.parseBoolean(options[OPTIONS.MAXIMIZED.ordinal()]);
		 if (options.length > OPTIONS.LEFT_BACK.ordinal())
			 this.leftSameAsBack = Boolean.parseBoolean(options[OPTIONS.LEFT_BACK.ordinal()]);
	}
	
	private enum OPTIONS {
		MOBILE, SHOW_TV, MEDIA_STYLE, FONT_SCALE, MAXIMIZED, LEFT_BACK
	};

	private void saveOptions() {
		StringBuffer optionsString = new StringBuffer();
		optionsString.append(this.appearMobile).append(","); // 0 //$NON-NLS-1$
		optionsString.append(this.showTV).append(","); // 1 //$NON-NLS-1$
		optionsString.append(this.activeMediaStyle).append(","); // 2 //$NON-NLS-1$
		optionsString.append(this.fontScale).append(","); // 3 //$NON-NLS-1$
		optionsString.append(this.maximizedDisplay).append(","); //4 //$NON-NLS-1$
		optionsString.append(this.leftSameAsBack).append(","); //4 //$NON-NLS-1$

		getContext().setPersistentData(OPTIONS_KEY, optionsString.toString());
	}

	public boolean removeBookmark(URL urlBase, String titleString, URL icon) {
		if (!isBookmarksDisabled()) {
			String bookmarkString = getContext().getPersistentData(
					BOOKMARKS_KEY);
			if (bookmarkString == null) {
				bookmarkString = ""; //$NON-NLS-1$
			}
			bookmarkString = removeBookmark(bookmarkString, urlBase,
					titleString);
			getContext().setPersistentData(BOOKMARKS_KEY, bookmarkString);
			return true;
		} else {
			return false;
		}
	}

	public LinkedHashMap<String, URL[]> getBookmarks() {
		LinkedHashMap<String, URL[]> result = new LinkedHashMap<String, URL[]>();
		String bookmarkString = getContext().getPersistentData(BOOKMARKS_KEY);
		if (bookmarkString != null) {
			getBookmarks(result, bookmarkString);
		}
		return result;
	}

	private void getBookmarks(LinkedHashMap<String, URL[]> result,
			String bookmarkString) {
		String[] bookmarks = bookmarkString.split(BOOKMARK_ENTRY_SEP);
		for (String bookmark : bookmarks) {
			String[] parts = bookmark.split(BOOKMARK_URL_TITLE_SEP);
			if (parts.length == 3 || parts.length == 4) {
				URL url;
				try {
					url = new URL(parts[0]);
				} catch (MalformedURLException e) {
					System.err.println(e.toString());
					continue;
				}
				URL iconurl = null;
				// backward compatibility
				if (parts.length == 4) {
					saveCookie(url, parts[2]);
					try {
						iconurl = new URL(url, parts[1]);
					} catch (MalformedURLException e) {
						continue;
					}
				} else
					saveCookie(url, parts[1]);
				result.put(parts[parts.length - 1], new URL[] { url, iconurl });
			}
		}
	}

	private String addBookmark(String bookmarkString, URL urlBase2,
			String titleString2, URL icon) {
		String iconString = getRelativeURL(urlBase2, icon);
		if (iconString == null) {
			iconString = ""; //$NON-NLS-1$
		} else
			debugOut("bookmark icon:" + iconString); //$NON-NLS-1$
		String bookmark = urlBase2.toString() + BOOKMARK_URL_TITLE_SEP
				+ iconString + BOOKMARK_URL_TITLE_SEP;
		String cookies = getSavedCookie(urlBase2);
		if (cookies != null) {
			bookmark += cookies;
		}
		bookmark += BOOKMARK_URL_TITLE_SEP + titleString2;
		if (bookmarkString.length() > 0) {
			return bookmarkString + BOOKMARK_ENTRY_SEP + bookmark;
		} else {
			return bookmark;
		}
	}

	public static String getRelativeURL(URL urlBase, URL icon) {
		if (icon == null)
			return null;
		if (urlBase.getProtocol().equals(icon.getProtocol())
				&& urlBase.getHost().equals(icon.getHost())
				&& urlBase.getPort() == icon.getPort()) {
			// TODO should be able to just check urlBase.getAuthority() to
			// include everything at once including userInfo, but I'm not
			// certain that's always set...?
			String base = urlBase.getFile();
			String rel = icon.getFile();
			String newRel = rel;
			int bi = base.indexOf("/"); //$NON-NLS-1$
			int ri = rel.indexOf("/"); //$NON-NLS-1$
			while (bi != -1 && bi == ri
					&& base.substring(0, bi).equals(rel.substring(0, ri))) {
				newRel = rel.substring(ri);
				bi = base.indexOf("/", bi + 1); //$NON-NLS-1$
				ri = base.indexOf("/", ri + 1); //$NON-NLS-1$
			}
			debugOut(newRel + " = " + icon + " - " + urlBase); //$NON-NLS-1$ //$NON-NLS-2$
			return newRel;
		}
		return icon.toString();
	}

	private String removeBookmark(String bookmarkString, URL urlBase,
			String titleString) {
		String result = null;
		if (bookmarkString != null) {
			String[] bookmarks = bookmarkString.split(BOOKMARK_ENTRY_SEP);
			for (String bookmark : bookmarks) {
				if (bookmark.startsWith(urlBase.toString()
						+ BOOKMARK_URL_TITLE_SEP)) {
					// skip it.
				} else {
					if (result != null && result.trim().length() != 0) {
						result = result + BOOKMARK_ENTRY_SEP + bookmark;
					} else {
						result = bookmark;
					}
				}
				// String[] parts = bookmark.split("\t");
				// if(parts.length == 2) {
				// }
			}
		}
		if (result == null) {
			return ""; //$NON-NLS-1$
		}
		return result;
	}
	
	void refreshBookmarks() {
		if(isBookmarksDisabled()) return;
		
		String result = "";
		String bookmarkString = getContext().getPersistentData(
				BOOKMARKS_KEY);
		if (bookmarkString == null) {
			bookmarkString = ""; //$NON-NLS-1$
		}
		
		String[] bookmarks = bookmarkString.split(BOOKMARK_ENTRY_SEP);
		for (String bookmark : bookmarks) {
			String[] parts = bookmark.split(BOOKMARK_URL_TITLE_SEP);
			if (parts.length == 3 || parts.length == 4) {
				URL url;
				try {
					url = new URL(parts[0]);
				} catch (MalformedURLException e) {
					System.err.println(e.toString());
					continue;
				}
				URL iconurl = null;
				// backward compatibility
				if (parts.length == 4) {
					try {
						iconurl = new URL(url, parts[1]);
					} catch (MalformedURLException e) {
						continue;
					}
				}
				String title = parts[parts.length - 1];
				
				// gets the most recent cookie when it adds the bookmark.
				result = addBookmark(result, url, title, iconurl);
			}
		}
		
		getContext().setPersistentData(BOOKMARKS_KEY, result);		
	}	

	public void setLastVisited(URL url, String title) {
		if (url == null) {
			return;
		}
		if (title == null) {
			title = url.toString();
		}
		getContext().setPersistentData(LAST_TITLE_KEY, title);
		getContext().setPersistentData(LAST_URL_KEY, url.toString());
	}

	URL getLastVisited() {
		String urlString = getContext().getPersistentData(LAST_URL_KEY);
		if (urlString != null) {
			// change to URL
			try {
				return new URL(urlString);
			} catch (MalformedURLException e) {
				return null;
			}
		}
		return null;
	}

	String getLastVisitedTitle() {
		String titleString = getContext().getPersistentData(LAST_TITLE_KEY);
		return titleString;
	}

	private void saveCookie(URL urlBase, String cookie2) {
		if (cookie2 == null || urlBase == null || cookie2.length() == 0)
			return;

		java.net.URI uri;
		try {
			uri = urlBase.toURI();
		} catch (URISyntaxException e) {
			debugOut("CAN'T SAVE COOKIE FOR " + urlBase + ": " + e); //$NON-NLS-1$ //$NON-NLS-2$
			return;
		}
		CookieStore cookies = ((CookieManager) CookieHandler.getDefault())
				.getCookieStore();
		List<HttpCookie> cookieSet = HttpCookie.parse(cookie2);
		for (HttpCookie cookie : cookieSet) {
			cookies.add(uri, cookie);
		}
	}

	private String getSavedCookie(URL urlBase) {
		if (urlBase == null)
			return null;

		java.net.URI uri;
		try {
			uri = urlBase.toURI();
		} catch (URISyntaxException e) {
			debugOut("CAN'T get SAVED COOKIE FOR " + urlBase + ": " + e); //$NON-NLS-1$ //$NON-NLS-2$
			return null;
		}
		CookieStore cookies = ((CookieManager) CookieHandler.getDefault())
				.getCookieStore();
		List<HttpCookie> cookieSet = cookies.get(uri);

		StringBuffer cookieString = new StringBuffer();
		for (int i = 0; i < cookieSet.size(); ++i) {
			if (i != 0) {
				cookieString.append(","); //$NON-NLS-1$
			}
			// FIXME make sure the toString() includes domain, etc.
			cookieString.append(cookieSet.get(i));
		}
		return cookieString.toString();
	}

	private TeDict getSavedCookiesAsTeDict(URL urlBase) {
		if (urlBase == null)
			return null;

		java.net.URI uri;
		try {
			uri = urlBase.toURI();
		} catch (URISyntaxException e) {
			debugOut("CAN'T get SAVED COOKIE FOR " + urlBase + ": " + e); //$NON-NLS-1$ //$NON-NLS-2$
			return null;
		}
		CookieStore cookies = ((CookieManager) CookieHandler.getDefault())
				.getCookieStore();
		List<HttpCookie> cookieSet = cookies.get(uri);

		TeDict result = new TeDict();
		for (HttpCookie cookie : cookieSet) {
			//FIXME getValue probably isn't the entire cookie spec..
			//   might have to use toString and trim off the "name="
			String cookieString = cookie.toString();
			//FIXME simulator is doc'd to not support quoted strings which this gives you.
			String cookieVal = cookieString.substring(cookieString.indexOf("=")+1); //$NON-NLS-1$
			//cookie.toString());
//			cookie.getValue());
			
			result.add(cookie.getName(), cookieVal);
		}
		return result;
	}
	
	@Override
	public boolean handleIdle(boolean isIdle) {
		if (isIdle && getCurrentScreen() != null
				&& getCurrentScreen() instanceof WebScreen
				&& ((WebScreen) getCurrentScreen()).dontTimeout()) {
			acknowledgeIdle(true);
			return true;
		}
		return super.handleIdle(isIdle);
	}

	/* BEGIN Homegrown impl */
	// public URLConnection openLink(URL urlBase, URL referer)
	// throws IOException {
	// return openLink(urlBase, referer, null, null);
	// }
	//
	// private URLConnection openLink(URL urlBase, URL referer, String method,
	// String data)
	// throws IOException {
	// URLConnection connection = urlBase.openConnection();
	// // HttpsURLConnection sconn = (HttpsURLConnection) connection;
	// if(connection instanceof HttpURLConnection) {
	// HttpURLConnection hconn = (HttpURLConnection) connection;
	// if(method != null) {
	// hconn.setRequestMethod(method);
	// }
	// String cookie = getSavedCookie(urlBase);
	// if (cookie != null) {
	// for (String c : cookie.split(";")) {
	// if (c != null && c.trim().length() > 0) {
	// debugOut(COOKIE+":"+c);
	// hconn.addRequestProperty(COOKIE, c);
	// }
	// }
	// }
	// hconn.setRequestProperty(USER_AGENT, getUserAgent());
	//
	// if(method != null && method.equals(METHOD_POST) && data != null) {
	// // Send data
	// hconn.setDoOutput(true);
	// OutputStreamWriter wr = new OutputStreamWriter(hconn.getOutputStream());
	// debugOut("POST:"+data);
	// wr.write(data);
	// wr.flush();
	// }
	// // connection.getRequestProperties()
	// // connection.guessContentTypeFromName(BROWSER_NAME)
	// connection.connect();
	//
	// cookie = getCookies(hconn);
	// saveCookie(urlBase, cookie);
	// }
	// return connection;
	// }
	//
	// private String getCookies(HttpURLConnection hconn) {
	// List<String> cookies = hconn.getHeaderFields().get(SET_COOKIE);
	// debugOut(SET_COOKIE+":"+cookies);
	// if(cookies == null) return null;
	// StringBuffer cookieBuffer = new StringBuffer();
	// for(String cookie : cookies) {//TODO not robust
	// cookieBuffer.append(cookie.split(";")[0]).append(";");
	// }
	// return cookieBuffer.toString();
	// }
	//
	// public URLConnection doPost(String submitAction, String encoding,
	// LinkedHashMap<String, String> fields, URL referer) {
	// if (submitAction == null && referer != null) {
	// submitAction = referer.toString();
	// }
	// if(encoding == null) {
	// encoding = "UTF-8";
	// }
	// String data = getData(encoding, fields);
	//
	// try {
	// debugOut(submitAction.toString());
	// URL getURL = new URL(submitAction.toString());
	// URLConnection conn = openLink(getURL, referer, METHOD_POST, data);
	// return conn;
	// } catch (MalformedURLException e) {
	// return null;
	// } catch (IOException e) {
	// return null;
	// }
	// //System.err.println("not implemented: POST form for "+submitAction);
	// }
	// public URLConnection doGet(String submitAction, String encoding,
	// LinkedHashMap<String, String> formSubmission, URL referer) {
	//
	// if(encoding == null) {
	// encoding = "UTF-8";
	// }
	// StringBuffer submitLink = new StringBuffer(submitAction);
	// if(formSubmission.size() > 0) {
	// if(submitLink.indexOf("?")<0) {
	// submitLink.append("?");
	// }
	// String data = getData(encoding, formSubmission);
	// if(data !=null)
	// submitLink.append(data);
	// }
	// try {
	// debugOut(submitLink.toString());
	// URL getURL = new URL(submitLink.toString());
	// return openLink(getURL, referer);
	// } catch (MalformedURLException e) {
	// return null;
	// } catch (IOException e) {
	// return null;
	// }
	// }
	// private String getData(String encoding,
	// LinkedHashMap<String, String> formSubmission) {
	// StringBuffer submitData = new StringBuffer();
	// try {
	// for (Entry<String, String> entry : formSubmission.entrySet()) {
	// if(entry.getKey() != null) {
	// submitData.append(URLEncoder.encode(entry.getKey(), encoding));
	// if(entry.getValue() != null) {
	// submitData.append("=");
	// submitData.append(URLEncoder.encode(entry.getValue(), encoding));
	// }
	// submitData.append("&");
	// }
	// }
	// int lastChar = submitData.length() - 1;
	// if (submitData.charAt(lastChar) == '&') {
	// submitData.deleteCharAt(lastChar);
	// }
	// } catch (UnsupportedEncodingException e) {
	// //Shouldn't be possible.
	// e.printStackTrace();
	// }
	// return submitData.toString();
	// }
	/* END Homegrown impl */

	/* BEGIN JSoup impl */
	public Response doPost(String submitAction, String encoding,
			ArrayList<String[]> formSubmission, URL referer) {
		Connection soupCon = Jsoupconnect(submitAction)
				.method(Method.POST);
		if (formSubmission != null) {
			for(String[] submission : formSubmission) {
				soupCon.data(submission[0],submission[1]);
			}
		}
		String referrer = null;
		if (referer != null) {
			referrer = referer.toString();
		}
		soupCon.referrer(referrer);
		
		debugOut("POST:" + submitAction + "?" + formSubmission); //$NON-NLS-1$ //$NON-NLS-2$
		Response res;
		try {
			soupCon.followRedirects(false);
			res = soupCon.execute();
			res = followRedirects(res, referrer);
		} catch (IOException e) {
			// this throws IOException only on a real error (not http error, and
			// doesn't parse so not contenttype).
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		return res;
	}

	/**
	 * perform {@link Jsoup#connect(String)} and do some standard configuration
	 * (timeout, ignoreHttpErrors, and userAgent)
	 * 
	 * @param connectURL
	 * @return
	 */
	Connection Jsoupconnect(String connectURL) {
		return Jsoup.connect(connectURL)				
				.timeout(CONNECTION_TIMEOUT) // override the 3 second default
				.ignoreHttpErrors(true) // show errors as a page
				.userAgent(getUserAgent());
	}

	public Response getResponse(URL urlBase, URL referer) throws IOException {
		// This was just a stopgap, now JSoup throws
		// UnsupportedMimeTypeException
		// which gives the final content type and url without downloading stream
		// String contentGuess = guessContentType(urlBase);
		// // if we know this isn't expected to be a webpage, return null
		// if(contentGuess == null || contentGuess.startsWith("text/")) {

		Connection con = Jsoupconnect(urlBase.toString())
				// TODO could allow HTTP Exception instead and show as a popup
//				.ignoreHttpErrors(false)
				;
		String referrer = null;
		if (referer != null) {
			referrer = referer.toString();
			con.referrer(referrer);
		}
		// this throws IOException only on a real error (not http error, and
		// doesn't parse so not contenttype).
		// it also throws UnsupportedMimeTypeException and
		// SocketTimeoutException
		con.followRedirects(false);
		Response result = con.execute();
		result = followRedirects(result, referrer);

		return result;
		// } else {
		// return null;
		// }
	}

	public Response doGet(String submitAction, String encoding,
			ArrayList<String[]> formSubmission, URL referer) {

		Connection soupCon = Jsoupconnect(submitAction)
				.method(Method.GET);
		if (formSubmission != null) {
			for(String[] submission : formSubmission) {
				soupCon.data(submission[0],submission[1]);
			}
		}
		String referrer = null;
		if (referer != null) {
			referrer = referer.toString();
		}
		soupCon.referrer(referrer);

		debugOut("GET:" + submitAction + "?" + formSubmission); //$NON-NLS-1$ //$NON-NLS-2$
		Response res;
		try {
			soupCon.followRedirects(false);
			res = soupCon.execute();
			res = followRedirects(res, referrer);
		} catch (IOException e) {
			// this throws IOException only on a real error (not http error, and
			// doesn't parse so not contenttype).
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		return res;
	}

	/**
	 * {@link HttpURLConnection#guessContentTypeFromName(String)} plus some
	 * additional guesses
	 * 
	 * @param urlBase
	 * @return
	 */
	static String guessContentType(URL urlBase) {
		String contentGuess = HttpURLConnection
				.guessContentTypeFromName(urlBase.getPath());
		if (contentGuess == null) {
			if (urlBase.getPath() != null) {
				String path = urlBase.getPath().toLowerCase();
				if (path.endsWith(".mp4")) { //$NON-NLS-1$
					contentGuess = "video/mp4"; //$NON-NLS-1$
				} else if (path.endsWith(".mp3")) { //$NON-NLS-1$
					contentGuess = "audio/mpeg"; //$NON-NLS-1$
				}
			}
		}
		// debugOut("guess: "+contentGuess+" "+urlBase.getPath()
		// +" --- "+urlBase);
		return contentGuess;
	}

	public Pattern redirectErrorPattern = Pattern
			.compile("^HTTP Error 30[12]\\.\\s*(.+)\\s*$"); //$NON-NLS-1$

	public boolean handleRedirectError(final BView view, HmeEvent event,
			String errorText, URL referer) {
		if (errorText != null) {
			Matcher m = redirectErrorPattern.matcher(errorText);
			if (m.matches()) {
				debugOut("Matched redirect error... " + m.group(1)); //$NON-NLS-1$
				try {
					// unfortunately, this url isn't from the error, it's the
					// original one
					String url = m.group(1);
					if (url != null) {
						URL resURL = new URL(url.trim());
						URL newresURL = resolveRedirects(resURL, referer);
						if (!resURL.equals(newresURL)) {
							Resource newres = view.getResource(newresURL);
							if (newres != null) {
								newres.addHandler(this);
								view.setResource(newres);

								Resource res = this.getResource(event.getID());
								if (res != null) {
									res.removeHandler(this);
								}
								return true;
							}
						}
					}
				} catch (MalformedURLException e) {
					// give up and continue with regular error display
				}
			}
		}
		return false;
	}

	// public boolean handleStreamRedirectError(final BView view, HmeEvent
	// event,
	// String errorText, String contentType) {
	// if (errorText != null) {
	// Matcher m = redirectError.matcher(errorText);
	// if (m.matches()) {
	// debugOut("Matched redirect error... "+m.group(1));
	// try {
	// //unfortunately, this url isn't from the error, it's the original one
	// String url = m.group(1);
	// if (url != null) {
	// URL resURL = new URL(url.trim());
	// URL newresURL = resolveRedirects(resURL, null);
	// if(!resURL.equals(newresURL)) {
	// Resource newres = view.createStream( newresURL.toString(), contentType,
	// true);
	// // Resource newres = view.getResource(newresURL);
	// if(newres != null) {
	// newres.addHandler(this);
	// view.setResource(newres);
	//
	// Resource res = this.getResource(event.getID());
	// if(res != null) {
	// res.removeHandler(this);
	// }
	// return true;
	// }
	// }
	// }
	// } catch (MalformedURLException e) {
	// // give up and continue with regular error display
	// }
	// }
	// }
	// return false;
	// }

	/**
	 * tries to go through all the redirects, including with cookies. If the
	 * result we don't get anywhere or the new url is the same as the old one,
	 * returns null.
	 * 
	 * @param newresURL
	 * @param referer
	 * @return
	 */
	public URL resolveRedirects(URL newresURL, URL referer) {
		boolean redirect = true;
		while (redirect) {
			URLConnection c;
			try {

				// FIXME replace withJSoup version! and add Referer to JSoup
				// version if that's correct to do!
				// TODO ok, did that, sortof...haven't really checked my work, though
				// FIXME this is only used by VideoWatcher currently
				String referrer = null;
				if (referer != null) {
					referrer = referer.toString();
				}
				Response resp = followRedirects(Jsoupconnect(newresURL.toString()).followRedirects(false)
						.referrer(referrer)
						.execute(), referrer);
				return resp.url();
				// c = newresURL.openConnection();
				// if(c instanceof HttpURLConnection) {
				// HttpURLConnection h = (HttpURLConnection) c;
				// h.setInstanceFollowRedirects(false);
				// if(referer != null) {
				// h.addRequestProperty(HTTP_HEADER_REFERER,
				// referer.toString());
				// }
				// try {
				// h.connect();
				// int respcode = h.getResponseCode();
				// if(respcode == 301 || respcode == 302) {
				// String newString = h.getHeaderField(HTTP_HEADER_LOCATION);
				// debugOut("Redirect "+newresURL+" to "+newString);
				// if(newString == null || newString.trim().length() == 0) {
				// // give up and return what we have.
				// return newresURL;
				// }
				// newresURL = new URL(newresURL, newString.trim());
				// } else {
				// debugOut("not redirect "+respcode+" "+h.getResponseMessage());
				// redirect = false;
				// }
				// } finally {
				// h.disconnect();
				// }
				// }
			} catch (IOException e) {
				// return the best we have.
				return newresURL;
			}
		}
		return newresURL;
	}

	/* END JSoup impl */

	private Map<String, Object> resourceDetail = Collections
			.synchronizedMap(new HashMap<String, Object>());

	public Object getResourceCache(String src) {
		synchronized (resourceDetail) {			
			return resourceDetail.get(src);
		}
	}

	public void putResourceCache(String src, Object obj) {
		synchronized (resourceDetail) {			
			resourceDetail.put(src, obj);
		}
	}

	private boolean waitingToInit;

	@Override
	public void rootBoundsChanged(Rectangle rootBounds) {
		super.rootBoundsChanged(rootBounds);
		if (rootBounds.getHeight() > 480) {
			super.setSkin(hdSkin);
		}
		if (isResolutionSupported()) {
			if (waitingToInit) {
				waitingToInit = false;
				showFirstPage();
			}
		}
	}

	/* BEGIN fix JDK */

	/**
	 * according to an error logged:
	 * "rendered text exceeded max allowed dimensions of 1920x1080"
	 */
	public static final int LIMIT_TEXT_RENDER_WIDTH = 1920;
	/**
	 * according to an error logged:
	 * "rendered text exceeded max allowed dimensions of 1920x1080"
	 */
	public static final int LIMIT_TEXT_RENDER_HEIGHT = 1080;

	/** Media status code, resource at end of stream. */
	public static final int RSRC_STATUS_END = 11;
	/** Media status code, resource at end of available buffer. */
	public static final int RSRC_STATUS_BUFFER_OVERFLOW = 12;

	/**
	 * "A" remote button, only available (transmitted over HME) on Premiere or
	 * Comcast, apparently
	 */
	public static final int KEY_OPT_A = 56;
	/**
	 * "B" remote button, only available (transmitted over HME) on Premiere or
	 * Comcast, apparently
	 */
	public static final int KEY_OPT_B = 57;
	/**
	 * "C" remote button, only available (transmitted over HME) on Premiere or
	 * Comcast, apparently
	 */
	public static final int KEY_OPT_C = 58;
	/**
	 * "D" remote button, only available (transmitted over HME) on Premiere or
	 * Comcast, apparently
	 */
	public static final int KEY_OPT_D = 59;

	/**
	 * HTTP Header sent in resource requests by the TiVo with the tsn (context
	 * connection attribute "tsn") as value
	 */
	public static final String HTTP_HEADER_TIVO_ID = "TiVo_TCD_ID"; //$NON-NLS-1$
	/**
	 * HTTP Header sent in resource requests by the TiVo with the TiVo Software
	 * Version (Device Info event's "version") as value
	 */
	public static final String HTTP_HEADER_TIVO_VERSION = "TiVo_SW_VER"; //$NON-NLS-1$
	public static final String HTTP_HEADER_TIVO_DURATION = IHmeConstants.TIVO_DURATION;

	/** Device Info event's "version" - the TiVo Software Version */
	protected String tivoVersion;

	private boolean destroyedAlready = false;

	public void destroy() {
		// protect against SDK bug: if there is a fatal error during below
		// operations (e.g. remove operations) close gets called which calls
		// destroy again.

		// what happens: after the 2nd call to here, we'll get HMEException from
		// the remove call that caused it which contains the actual cause
		// (unless it was originally an HMEException)
		// setId(-1) has not been called on the object yet

		// SO: want to catch HMEExceptions if we want to finish our destroy
		// operation
		if (destroyedAlready)
			return;
		destroyedAlready = true;

		// ... operations that could cause a fatal error, e.g. "remove" calls

		super.destroy(); // in case e.g. BApplication ever starts doing
							// something there.
	}

	/**
	 * Improved version of
	 * {@link Application#handleApplicationError(int, String)} that includes the
	 * resourceId related to the error - critical for knowing when you have a
	 * problem with a resource you created. Default implementation simply calls
	 * {@link #handleApplicationError(int, String)}. ApplicationError codes 1
	 * (e.g. "can't create rsrc. unsupported stream type
	 * /avatar/cf1e61a4330e75d5d1d7a744c5ef38c4") and 3 (e.g. "resource 2091 not
	 * found (type type[-1])") about a resource never provide a resourceinfo
	 * event!
	 * 
	 * @param errorCode
	 *            the error code of the error (one of the {@link IHmeProtocol}
	 *            APP_ERROR_ constants)
	 * @param errorText
	 *            details of the error
	 * @param resourceId
	 *            the id associated with the error - could be null. Suitable for
	 *            use with {@link #getResource(Object)} (or ((WeakReference)
	 *            {@link #getResources()}.get(Object)).get() to avoid automatic
	 *            SDK warning message when it's not found)
	 * @return true if the event was handled.
	 */
	public boolean handleApplicationError(int errorCode, String errorText,
			Integer resourceId) {
		if (handleApplicationError(errorCode, errorText)) {
			return true;
		} else {
			// FIXME add processing needed by e.g. image exceeding max width or
			// height (errorCode 2) with no resource id
			return false;
		}
	}

	// public boolean handleChunk(InputStream in)
	// {
	// synchronized (lock) {
	// //debug("handleChunk()");
	// boolean doMore = true;
	//
	// // flush any data that was generated from previous handling of
	// // event
	// flush();
	//
	// ChunkedInputStream chunkInStr = null;
	// if (in instanceof ChunkedInputStream)
	// {
	// chunkInStr = (ChunkedInputStream)in;
	// }
	// else
	// {
	// chunkInStr = new ChunkedInputStream(in); //,
	// IHmeConstants.TCP_BUFFER_SIZE);
	// }
	//
	// // if ( protocolVersion < VERSION_0_40 )
	// // {
	// // chunkInStr.setUseVString( false );
	// // }
	// // else {
	// chunkInStr.setUseVString( true );
	// // }
	//
	// int opcode = -1;
	// try {
	// opcode = (int)chunkInStr.readVInt();
	// } catch (IOException e) {
	// // receiver closed - ignore
	// // if (debug()) {
	// // log(ILogger.LOG_DEBUG,
	// // "Connection terminated by receiver");
	// // }
	// }
	// if (opcode == -1) {
	// doMore = false;
	// return doMore;
	// }
	//
	// HmeEvent evt = null;
	// String eventString = null;
	// try
	// {
	// switch (opcode) {
	// case EVT_DEVICE_INFO:
	// evt = new HmeEvent.DeviceInfo(chunkInStr);
	// break;
	// case EVT_APP_INFO:
	// evt = new HmeEvent.ApplicationInfo(chunkInStr);
	// break;
	// case EVT_RSRC_INFO:
	// evt = new HmeEvent.ResourceInfo(chunkInStr, this);
	// break;
	// case EVT_RESOLUTION_INFO:
	// evt = new HmeEvent.ResolutionInfo(chunkInStr);
	// break;
	// case EVT_KEY:
	// evt = new HmeEvent.Key(chunkInStr);
	// break;
	// case EVT_IDLE:
	// evt = new HmeEvent.Idle(chunkInStr);
	// break;
	// case EVT_FONT_INFO:
	// evt = new HmeEvent.FontInfo(chunkInStr);
	// break;
	// case EVT_INIT_INFO:
	// evt = new HmeEvent.InitInfo(chunkInStr);
	// break;
	// default:
	// eventString =
	// "HmeEvent[opcode=" + opcode
	// + ", id = " + chunkInStr.readVInt()
	// + "]";
	// // short clen = chunkInStr.readShort();
	// // while (clen != 0) {
	// // System.out.println(clen);
	// // chunkInStr.skip(clen);
	// // clen = chunkInStr.readShort();
	// // }
	//
	// // System.out.println(eventString);
	// // try {
	// // System.out.println(chunkInStr.readInt());
	// // System.out.println(chunkInStr.readDict());
	// // } catch(IOException e1) {
	// // chunkInStr.readTerminator();
	// // throw e1;
	// // }
	// break;
	// }
	// if (evt != null) {
	// evt.setMonitor(lock);
	// }
	// chunkInStr.readTerminator();
	// }
	// catch (IOException e) {
	// evt = null;
	// getLogger().log(ILogger.LOG_INFO, e);
	// }
	//
	// //
	// // Save the event, in case we need to dump the list
	// //
	// // if (eventsReceived != null) {
	// // if (eventsReceived.size() >= MAX_RECEIVED_EVENTS_SIZE) {
	// // // Startup is complete -- stop checking for protocol errs
	// // startupComplete = true;
	// // eventsReceived.clear();
	// // eventsReceived = null;
	// // } else {
	// // if (evt != null) {
	// // eventString = evt.toString();
	// // }
	// // if (eventString == null) {
	// // eventString = "Bad HmeEvent[opcode="+opcode+", no ID]";
	// // }
	// // eventsReceived.add(eventString);
	// // }
	// // }
	//
	// if (evt == null) {
	// getLogger().log(ILogger.LOG_DEBUG,
	// "unknown event opcode : " + opcode);
	// }
	// else
	// {
	// // if any debugging is turned on, verify the event is kosher
	// // if (debug()) {
	// // evt.verify(logger);
	// // }
	//
	// // debugEvents means to print each and every event received
	// // if (debugEvents()) {
	// getLogger().log(ILogger.LOG_DEBUG, "event " + evt);
	// // }
	//
	// // if (!preprocessEvent(evt)) {
	// //
	// // // preprocessEvent() says this event should be discarded
	// // if (eventsReceived != null) {
	// // int i = eventsReceived.size() - 1;
	// // eventsReceived.set(i,
	// // eventsReceived.get(i).toString() + " [IGNORED]");
	// // }
	//
	// // } else {
	//
	// // The app should receive this event.
	// //
	// // Only dispatch events after app.init() is called.
	// // Save events before init(), to be dispatched later.
	// //
	// // if (appInitialized) {
	// // dispatchEvent(evt);
	// // } else if (queuedEvents != null) {
	// // // Save the events to send after initialization
	// // queuedEvents.add(evt);
	// // }
	// // }
	// }
	//
	// // flush any data that was generated from handling of event
	// flush();
	//
	// return doMore;
	// } // sync
	//
	// } // handleChunk()

	public boolean handleEvent(HmeEvent event) {
		// get tivo version from device info
		if (event.getOpCode() == EVT_DEVICE_INFO) {
			HmeEvent.DeviceInfo info = (DeviceInfo) event;
			this.tivoVersion = (String) info.getMap().get("version"); //$NON-NLS-1$
			// com.tivo.examine.idType.stationId=tivo,
			// platform=Gen06,
			// host=Bedroom,
			// brand=TiVo,
			// com.tivo.examine.showing=true,
			// com.tivo.examine.idType.contentId=tivo,
			// version=11.0k-01-2-652
		}
		if (event.getOpCode() == EVT_INIT_INFO) {
			// use our memento we stored when we transitioned to another app
			HmeEvent.InitInfo info = (HmeEvent.InitInfo) event;
			handleMemento(info.getMemento());
			debugOut("PARAMS:" + info.getParams()); //$NON-NLS-1$
		}

		// ...
		if (event.getOpCode() == EVT_APP_INFO) {
			HmeEvent.ApplicationInfo info = (HmeEvent.ApplicationInfo) event;
			if (info.getMap().get("error.code") != null) { //$NON-NLS-1$
				int errorCode = Integer.parseInt((String) info.getMap().get(
						"error.code")); //$NON-NLS-1$
				Integer resourceId = null;
				if (info.getMap().get("error.rsrc") != null) { //$NON-NLS-1$
					try {
						resourceId = new Integer((String) info.getMap().get(
								"error.rsrc")); //$NON-NLS-1$
					} catch (NumberFormatException e) {
						resourceId = null;
					}
				}
				String errorText = (String) info.getMap().get("error.text"); //$NON-NLS-1$
				if (resourceId != null) {
					WeakReference res_wr = (WeakReference) getResources().get(
							resourceId);
					if (res_wr != null && res_wr.get() != null) {
						Resource res = (Resource) res_wr.get();
						Map resInfoMap = info.getMap();
						// TODO we're doing this regardless of whether it's
						// actually a change in status
						if (res.status == Resource.RSRC_STATUS_ERROR) {
							debugOut("NOTE: had to send ResourceStatus event for error even though resource's status was already error."); //$NON-NLS-1$
						}
						debugOut("Posting APP_INFO resource error to resource " //$NON-NLS-1$
								+ resourceId + ": " + resInfoMap); //$NON-NLS-1$
						res.postEvent(new MockResourceStatus(resourceId
								.intValue(), res, Resource.RSRC_STATUS_ERROR,
								resInfoMap));
					}
				} else
					debugOut("APP_INFO error " + errorCode + ": " + errorText); //$NON-NLS-1$ //$NON-NLS-2$

				return handleApplicationError(errorCode, errorText, resourceId);
			}
		}

		boolean result = super.handleEvent(event);
		// ...

		return result;
	}

	/**
	 * unfortunately sdk's Resource.ResourceStatus isn't public, so we recreate
	 * it here - all it does is use a different Event ID
	 */
	private static class MockResourceStatus extends HmeEvent.ResourceInfo {
		MockResourceStatus(int id, Resource rsrc, int status, Map map) {
			super(EVT_RSRC_STATUS, id, rsrc, status, map);
		}

		public String toString() {
			return getID() + ".RSRC_STATUS(" + statusToString(getStatus()) //$NON-NLS-1$
					+ ")"; //$NON-NLS-1$
		}
	}

	/**
	 * SDK Bug Fix - OMG! sick bug in HMEObject that has never been noticed or
	 * exercised since nobody has apparently attempted to do App-in-app with
	 * {@link #createStream(String, Map)}. They forgot a "new" keyword and
	 * auto-"fixed" the problem creating a method named LinkedHashMap that has
	 * default method content returning null! Also, calling code won't handle
	 * the nulls that are returned in certain circumstances, so now returning an
	 * empty map here. Lucky for us it is public and non-final. {@inheritDoc}
	 * 
	 * @see com.tivo.hme.sdk.HmeObject#parseQuery(java.lang.String)
	 */
	public Map parseQuery(String query) {
		Map map = new LinkedHashMap();
		if (query == null || query.indexOf('=') == -1) {
			return map;
		}

		int at = 0;
		int len = query.length();

		if (query.startsWith("?")) { //$NON-NLS-1$
			++at;
		}
		do {
			// find = and &
			int equal = query.indexOf('=', at);
			if (equal < 0) {
				throw new IllegalArgumentException(
						"invalid query (trailing key, = not found)"); //$NON-NLS-1$
			}
			int amp = query.indexOf('&', equal);
			if (amp == -1) {
				amp = query.length();
			}

			// add the key/value
			try {
				String key = URLDecoder.decode(query.substring(at, equal),
						"UTF-8"); //$NON-NLS-1$
				String value = URLDecoder.decode(
						query.substring(equal + 1, amp), "UTF-8"); //$NON-NLS-1$
				map.put(key.toLowerCase(), value);
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}

			// advance
			at = amp + 1;
		} while (at < len);
		return map;
	}

	/* END fix JDK */

	private String tivoID;
	public int protocolVersion;

	@Override
	protected void setContext(IContext context, int version) {
		super.setContext(context, version);
		// make accessible version of private Application class variable.
		this.protocolVersion = version;
		debugOut("Protocol Version per TiVo DVR: " + protocolVersion); //$NON-NLS-1$

		debugOut("attributes: " + context.getConnectionAttributes()); //$NON-NLS-1$
		// User-Agent: TvHttpClient -my tivo (and tsn=64...3E )
		// User-Agent: TmkHttpRequest/1.0 - from somebody on internet - old
		// version of tivo?
		// User-Agent=tivo.http/03/30/2003 - simulator
		// attributes: {Cookie=id=895df24b5038b953631128d3aa994863d51da2b1,
		// Host=192.168.0.20:7288, User-Agent=TvHttpClient, Connection=close,
		// tsn=64...3E}
		this.tivoID = context.getConnectionAttribute("tsn"); //$NON-NLS-1$
		// context.getConnectionAttribute(HTTP_HEADER_TIVO_ID);
		// tivoVersion is in DEVICE_INFO event under "version"
		// this.tivoVersion =
		// context.getConnectionAttribute(HTTP_HEADER_TIVO_VERSION);

		// try {
		// debugOut("headers from tivo: "+
		// context.getConnectionAttribute("Host"));
		// debugOut(Jsoup.connect("http://"+
		// context.getConnectionAttribute("Host")).ignoreHttpErrors(true).
		// execute().headers().toString());
		// } catch (IOException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
		// debugOut(HTTP_HEADER_TIVO_ID+": "+tivoID);
		// debugOut(HTTP_HEADER_TIVO_VERSION+": "+tivoVersion);

		// NOTE: for some reason all url-arg connection attributes have their
		// key's lowercased
		WebBrowserApp app = this;
		String instanceStartURL = context.getConnectionAttribute("url"); //$NON-NLS-1$
		if (instanceStartURL != null) {
			app.startURL = instanceStartURL;
			debugOut("CONNECTION ATTRIBUTE:" + app.startURL); //$NON-NLS-1$
		}
		String disableBookmarks = context
				.getConnectionAttribute("disablebookmarks"); //$NON-NLS-1$
		app.disableBookmarks = (disableBookmarks != null);
		// FIXME implement domain limiting code
		// String restrictDomain =
		// context.getConnectionAttribute("domainlimit");
		// ((WebBrowserApp)application).domainLimit = domainLimit;
		String font = context.getConnectionAttribute("fontscale"); //$NON-NLS-1$
		if (font != null) {
			try {
				app.fontScale = Float.parseFloat(font);
			} catch (Exception e) {
				WebBrowserApp.debugOut(e);
				// just don't set it.
			}
		}

	}

	public float getFontScaleRaw() {
		return fontScale;
	}

	public float getFontScale() {
		return getHDAdjustedFontScale(fontScale);
	}

	private float getHDAdjustedFontScale(float originalFontScale) {
		float ratio = ((float) getHeight()) / 480f;
		// make the used increase (amount over 1.0) a fraction of the ratio's
		// increase
		float increaseRate = .85f;
		float hdIncrease = 1.0f + (increaseRate * ratio - 1.0f);
		// debugOut("hdincrease: "+hdIncrease +" ... "+getHeight()+" v 480");
		if (hdIncrease <= 1.0f) {
			return originalFontScale;
		} else {
			return originalFontScale * hdIncrease;
		}
	}

	public void setFontScale(float fontScale) {
		this.fontScale = fontScale;
	}
	
	/**
	 * revert to font scale last saved with {@link #setFontKey(int)}
	 */
	public void restoreSavedFontScale() {
		float scale = getSavedFontScale();
		if(scale > 0f) {
			this.fontScale = scale;
		}
	}
	
	private float getSavedFontScale() {
		String optionsString = getContext().getPersistentData(OPTIONS_KEY);
		if (optionsString == null)
			return 0f;
		String[] options = optionsString.split(","); //$NON-NLS-1$
		if(options.length > 3)
			return Float.parseFloat(options[OPTIONS.FONT_SCALE.ordinal()]);
		return 0f;
	}

	public int getSavedFontKey() {
		float scale = getSavedFontScale();
		return getFontScaleKey(scale);
	}

	private Map<String, FontInfo> fontInfos = Collections
			.synchronizedMap(new HashMap<String, HmeEvent.FontInfo>());

	public Map<String, FontInfo> getFontInfos() {
		return fontInfos;
	}
	
	/**
	 * V Space from safeTitle bottom to bottom of scrolling area
	 */
	public int getSafeTitleToScrollBottom() {
		if (isResolutionSupported() && getCurrentResolution().getHeight() > 480) {
			return 30;
		} else {
			return 15; // SD number
		}
	}

	/**
	 * V Space from safeTitle top to top of scrolling area
	 */
	public int getSafeTitleToScrollTop() {
		if (isResolutionSupported() && getCurrentResolution().getHeight() > 480) {
			return 85 + 60;
		} else {
			return 95; // SD number
		}
	}
	
	/**
	 * H space from safeTitle left to right edge of TiVo logo in the title area
	 */
	public int getSafeLogoToScrollTitle() {
		if (isResolutionSupported() && getCurrentResolution().getHeight() > 480) {
			return 100; // could need a diff number for 720, but this will work.
		} else {
			return 45;// SD number - goes past "glow"
		}
	}


	/* BEGIN HME 1.4 only */
	public boolean isResolutionSupported() {
		int VERSION_0_41 = (0 << 8) | 41; // supported by sdk1.4
		int VERSION_0_43 = (0 << 8) | 43; // supported by sdk1.4.1e - Resolution
											// events
		int VERSION_0_45 = (0 << 8) | 45; // supported by sdk1.4.1e - maps in
											// stream resources
		int VERSION_0_49 = (0 << 8) | 49; // no sdk - Slide Remote key events
		// // return IHmeProtocol.VERSION > VERSION_0_41;
		// return this.protocolVersion > VERSION_0_41;
		return this.protocolVersion >= VERSION_0_43 && isSDK141();
	}

	public boolean isStreamMapSupported() {
		int VERSION_0_41 = (0 << 8) | 41; // supported by sdk1.4
		int VERSION_0_43 = (0 << 8) | 43; // supported by sdk1.4.1e - Resolution
											// events
		int VERSION_0_45 = (0 << 8) | 45; // supported by sdk1.4.1e - maps in
											// stream resources
		int VERSION_0_49 = (0 << 8) | 49; // no sdk - Slide Remote key events
		// // return IHmeProtocol.VERSION > VERSION_0_41;
		// return this.protocolVersion > VERSION_0_41;
		return this.protocolVersion >= VERSION_0_45 && isSDK141();
	}

	public boolean isSlideRemoteSupported() {
		int VERSION_0_41 = (0 << 8) | 41; // supported by sdk1.4
		int VERSION_0_43 = (0 << 8) | 43; // supported by sdk1.4.1e - Resolution
											// events
		int VERSION_0_45 = (0 << 8) | 45; // supported by sdk1.4.1e - maps in
											// stream resources
		int VERSION_0_49 = (0 << 8) | 49; // no sdk - Slide Remote key events
		// // return IHmeProtocol.VERSION > VERSION_0_41;
		// return this.protocolVersion > VERSION_0_41;
		return this.protocolVersion >= VERSION_0_49;
	}

	public boolean isSDK141() {
		try {
			if (Class.forName("com.tivo.hme.sdk.Version") != null) //$NON-NLS-1$
				return Version.getVersion().startsWith("1.4.1"); //$NON-NLS-1$
			else
				return false;
		} catch (ClassNotFoundException e) {
			return false;
		}
	}

	public int getSafeActionHorizontal() {
		if (!isSDK141()) {
			return SAFE_ACTION_H;
		} else {
			return super.getSafeActionHorizontal();
		}
	}

	public int getSafeTitleVertical() {
		if (!isSDK141()) {
			return SAFE_TITLE_V;
		} else {
			return super.getSafeTitleVertical();
		}
	}

	public int getSafeActionVertical() {
		if (!isSDK141()) {
			return SAFE_ACTION_V;
		} else {
			return super.getSafeActionVertical();
		}
	}

	public int getSafeTitleHorizontal() {
		if (!isSDK141()) {
			return SAFE_TITLE_H;
		} else {
			return super.getSafeTitleHorizontal();
		}
	}

	private int EVT_RESOLUTION_INFO = 8;
	private STATUS pleaseWaitStatus;

	protected void setMaxStackDepth(int max) {
		if (isSDK141()) {
			super.setMaxStackDepth(max);
		}
	}

	/* END HME 1.4 only */

	public TeDict getCookieTeDict(URL urlBase, URL referer) {
		if (urlBase == null)
			return null;
		
		//FIXME TeDict turned off for now... it apparently causes reboots when it's wrong
		debugOut("(disabled getCookieTeDict)"); //$NON-NLS-1$
		if(true) return null;
		
		TeDict result = new TeDict();
		// "Invalid parameter list"

		// try to get any set cookies and transfer them via the TeDict
		HttpURLConnection hconn = null;
		try {
			URLConnection connection = urlBase.openConnection();
			if (connection instanceof HttpURLConnection) {
				hconn = (HttpURLConnection) connection;

				// hconn.setRequestMethod("HEAD");//FIXME better, but could
				// prevent proper connection if server coded bad
				hconn.connect();
				hconn.disconnect();
			}
		} catch (Exception e) {
		}

		String headerValue = getSavedCookie(urlBase);
		if (headerValue != null) {
//			result.add(HTTP_HEADER_COOKIE, headerValue);
//			result.add(HTTP_HEADER_SET_COOKIE, headerValue); //THIS CAUSES A CRASH for vid stream... good sign, sort of!
			// options: 
			// break multi-cookie into multiple Set-Cookie entries
			// set cookie with a TeDict containing cookie name/value pairs
//			result.add(HTTP_HEADER_COOKIE.toLowerCase(), headerValue);
//			result.add(HTTP_HEADER_SET_COOKIE.toLowerCase(), headerValue);
		}
		
//		result.add(HTTP_HEADER_SET_COOKIE, "testSet=CookieSet");
		
		TeDict headers = new TeDict();
		TeDict cookies = getSavedCookiesAsTeDict(urlBase);
		if(urlBase != null && urlBase.toString().indexOf("EnterWebz")>-1) { //$NON-NLS-1$
			cookies.add("test", "TEST VALUE"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		if(cookies != null) {
			result.add(HTTP_HEADER_SET_COOKIE, cookies); // DIDN'T CRASH (on vid stream)! YAY! (crashed when I passed a string header-content)
			// but it DID crash when I also set "COOKIE" and "cookie" header names with string value.
			// ummm... ok, it crashed once on just an image... but cookies was empty... but that was done for other images on same page, too
			result.add(HTTP_HEADER_COOKIE, cookies);
			headers.add(HTTP_HEADER_COOKIE, cookies);
		}
		if(referer != null) {
			headers.add(HTTP_HEADER_REFERER, referer.toString());
			result.add(HTTP_HEADER_REFERER, referer.toString());
			result.add(HTTP_HEADER_REFERER.toLowerCase(), referer.toString());
		}
//		result.add("Request-Headers", headers);
//		result.add("Headers", headers);
//		result.add("Request", headers);
//		result.add("HTTP-Request", headers);
//		result.add("request", headers);
//		result.add("http-request", headers);
//		result.add("HTTP_Request", headers);
//		result.add("http_request", headers);
//		result.add("HTTP_REQUEST", headers);
//		result.add("HTTP-REQUEST", headers);

 debugOut(String.valueOf(result));
		return result;
		// TeDict result2 = new TeDict();
		// result2.add("HTTP-Header", result);
		// result2.add("Header", result);
		// result2.add("Headers", result);
		// result2.add("HTTP-Headers", result);
		// result2.add("HTTP-HEADER", result);
		// result2.add("HTTP_HEADER", result);
		// result2.add("HTTP-HEADERS", result);
		// result2.add("HTTP_HEADERS", result);
		// result2.add("HEADER", result);
		// result2.add("HEADERS", result);
		// result2.add("http-header", result);
		// result2.add("http_header", result);
		// result2.add("http-headers", result);
		// result2.add("http_headers", result);
		// result2.add("header", result);
		// result2.add("headers", result);
		// // try space instead of - also
		// result2.add("http", result);
		// result2.add("HTTP", result);
		// System.out.println(result2);
		// return result2;
	}

	/**
	 * Present TyPo keyboard for data entry (puts any live tv in the
	 * background).
	 * 
	 * @return the TyPo reference for further configuration
	 */
	public TyPo showTyPo() {
		backgroundLiveTV();
		// set up a global top-level keyboard for use throughout the app.
		if (this.typoScreen == null) {
			TyPo.setUserWordListAllowed(false);
			this.typoScreen = new TyPoScreen(this, this.protocolVersion);
			// this.typo = this.typoScreen.getTyPo();
			this.setTyPoSettings();
		}
		// try to look consistent with the source screen
		this.typoScreen
				.setResource(getCurrentScreen().getBelow().getResource());

		push(this.typoScreen, TRANSITION_NONE);
		return this.typoScreen.getTyPo();
	}

	/**
	 * Pops the TyPo screen if it's showing and resets most configuration of
	 * TyPo.
	 */
	public void closeTyPo() {
		if (getCurrentScreen() instanceof TyPoScreen)
			pop();
		// pop(((TyPoScreen)getCurrentScreen()).getTyPo().getValue());
		setTyPoSettings();
	}

	private void setTyPoSettings() {
		this.typoScreen.getTyPo().setKeyboard(Keyboard.DEFAULT);
		this.typoScreen.getTyPo().setActions(null, null);
		this.typoScreen.getTyPo().setActivateOnFocus(true);
		// this.typoScreen.getTyPo().setExitOptions(TyPo.EXIT_CANCEL,
		// TyPo.EXIT_FINISHED, true, false, false, false);
		this.typoScreen.getTyPo().setUseCompletions(true);
		// this.typoScreen.getTyPo().setValue("");
	}

	public static enum STATUS {
		CONNECTING, CONNECTING_STREAM, PARSING, PARSING_XML, PARSING_CSS, PARSING_HTML, REDIRECTING, COMPLETE
	};
	public void setLoadingStatus(STATUS status) {
		if(this.pleaseWait != null) {
			synchronized(this.pleaseWait) {
				this.pleaseWaitStatus = status;
				int statusTotal = STATUS.values().length;
				int percentInt = this.pleaseWaitStatus.ordinal()+1;
				float percent = (float)percentInt / (float)statusTotal;
				showProgress(percent);
			}
		}
	}

	private void showProgress(float percent) {
		if(this.pleaseWait.getChildCount() == 0) {
			if(isMaximized()) {
				new BView(this.pleaseWait, getSafeTitleHorizontal(), 0, 
						this.pleaseWait.getWidth()-2*getSafeTitleHorizontal(), 20);
			} else {
				new BView(this.pleaseWait, getSafeTitleHorizontal(), getSafeTitleVertical(), 
						this.pleaseWait.getWidth()-2*getSafeTitleHorizontal(), 20);
			}
		}
		BView prog = (BView) this.pleaseWait.getChild(0);
		prog.setSize((int) ((this.pleaseWait.getWidth()-2*getSafeTitleHorizontal())*percent), prog.getHeight());
		Color color = Color.green;
		if(STATUS.CONNECTING_STREAM.compareTo(this.pleaseWaitStatus) >= 0) {
			color = Color.yellow;
		} else if(STATUS.PARSING_HTML.compareTo(this.pleaseWaitStatus) >= 0) {
			color = Color.blue;
		} else if(STATUS.REDIRECTING.compareTo(this.pleaseWaitStatus) >= 0) {
			color = Color.orange;
		}
		prog.setResource(color);
	}
	
	public void setLoadingStatus(int progress, int maxProgress) {
		if(this.pleaseWait == null) return;
		synchronized(this.pleaseWait) {
			int statusTotal = STATUS.values().length;
			int percentInt = this.pleaseWaitStatus.ordinal()+1;
			float percent = (float)percentInt / (float)statusTotal;
			float partPercent = (float)progress / (float)maxProgress;
			percent += partPercent*(1f/(float)statusTotal); 
			showProgress(percent);
		}
	}
	
	public void showPleaseWait() {
		if (this.pleaseWait == null) {
			// set up a global top-level please-wait for use throughout the app.

			// this.pleaseWait = new PleaseWaitView(getAbove(), false);
			this.pleaseWait = new BView(getAbove(), 0, 0,
					getAbove().getWidth(), getAbove().getHeight(), false);
			this.pleaseWait.setResource(PleaseWaitView.DEFAULT_RESOURCE,
					RSRC_HALIGN_CENTER | RSRC_VALIGN_CENTER);
		}
		if (this.pleaseWait != null) {
			this.pleaseWait
					.setLocation((getNormal().getWidth() - this.pleaseWait
							.getWidth()) / 2,
							(getNormal().getHeight() - this.pleaseWait
									.getHeight()) / 2);
			this.pleaseWait.setVisible(true);
		}
	}

	public void hidePleaseWait() {
		if (this.pleaseWait != null)
			this.pleaseWait.setVisible(false);
	}

	HashMap<String, FontInfo> localFontInfos = new HashMap<String, FontInfo>();
	private MEDIA activeMediaStyle = MEDIA.TV;
	private boolean leftSameAsBack = true;
	static final float TEXT_SCALE_9 = 2.0f;
	static final float TEXT_SCALE_8 = 1.75f;
	static final float TEXT_SCALE_7 = 1.5f;
	static final float TEXT_SCALE_6 = 1.25f;
	static final float TEXT_SCALE_4 = .9f;
	static final float TEXT_SCALE_3 = .8f;
	static final float TEXT_SCALE_2 = .7f;
	static final float TEXT_SCALE_1 = .6f;
	static final float TEXT_SCALE_5 = 1.0f;
	public static enum MEDIA {TV, SCREEN, HANDHELD};

	/**
	 * Download a url's content and return as one big String. Doesn't go through
	 * JSoup (which won't get anything that's not text/*)
	 * 
	 * @param urlBase
	 * @return
	 */
	public String getRawText(URL urlBase) {
		try {
			URLConnection connection = urlBase.openConnection();
			//FIXME set headers!
			InputStream stream = connection.getInputStream();
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					stream));
			StringBuffer result = new StringBuffer();
			for (String line = reader.readLine(); line != null; line = reader
					.readLine()) {
				result.append(line).append("\n"); //$NON-NLS-1$
			}
			stream.close();
			return result.toString();
		} catch (IOException e) {
			return null;
		}
	}

	private static float[] text_scales = {WebBrowserApp.TEXT_SCALE_1, WebBrowserApp.TEXT_SCALE_2, WebBrowserApp.TEXT_SCALE_3, WebBrowserApp.TEXT_SCALE_4, WebBrowserApp.TEXT_SCALE_5, WebBrowserApp.TEXT_SCALE_6, WebBrowserApp.TEXT_SCALE_7, WebBrowserApp.TEXT_SCALE_8, WebBrowserApp.TEXT_SCALE_9};
	
	/**
	 * triggers {@link #saveOptions()}, unlike other variations.
	 */
	public void setFontKey(int key) {
		setFontScale(getFontScale(key));
		saveOptions();
	}
	
	public float getFontScale(int key) {
		if(key <= 0 || key >= text_scales.length+1)
			key = 5;
		return(text_scales[key-1]);
	}
	
	public int getFontScaleKey() {
		float scale = getFontScaleRaw();
		return getFontScaleKey(scale);
	}

	private int getFontScaleKey(float scale) {
		if(scale == WebBrowserApp.TEXT_SCALE_1)
			return 1;
		else if(scale == WebBrowserApp.TEXT_SCALE_2)
			return 2;
		else if(scale == WebBrowserApp.TEXT_SCALE_3)
			return 3;
		else if(scale == WebBrowserApp.TEXT_SCALE_4)
			return 4;
		else if(scale == WebBrowserApp.TEXT_SCALE_5)
			return 5;
		else if(scale == WebBrowserApp.TEXT_SCALE_6)
			return 6;
		else if(scale == WebBrowserApp.TEXT_SCALE_7)
			return 7;
		else if(scale == WebBrowserApp.TEXT_SCALE_8)
			return 8;
		else if(scale == WebBrowserApp.TEXT_SCALE_9)
			return 9;
		else return 5;
	}

	public boolean isMediaStyleActive(MEDIA type) {
		return type.equals(this.activeMediaStyle);
	}
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setMediaStyleActive(MEDIA type) {
		this.activeMediaStyle = type;
		saveOptions();
	}

	public boolean launchVideoPlayerApp(URL urlBase, String contentType) {
		String videoUrl= urlBase.toString();
		try {
			//TODO get decent titles out of url
			String title = urlBase.getPath();
			String subtitle = urlBase.getHost();
			String description = urlBase.toString();
			URL url = new URL("hme://204.176.49.116:7288/videoplayer?" //$NON-NLS-1$
					+ "title="+title //$NON-NLS-1$
					+ "&" //$NON-NLS-1$
					+ "subtitle="+subtitle //$NON-NLS-1$
					+ "&" //$NON-NLS-1$
					+ "description="+description //$NON-NLS-1$
					+ "&" //$NON-NLS-1$
					+ "uri="+URLEncoder.encode(videoUrl, "UTF-8") //$NON-NLS-1$ //$NON-NLS-2$
//				+"&" 
//				+"duration=1200"
					);
			loadApp(url);
			return true;
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// FIXME Auto-generated catch block
			e.printStackTrace();
		}
		
		return false;
	}

	public void handleMenuAction(String action) {
		if(action.startsWith(WebMenuScreen.MENU_FONT_PREFIX)) {
			int fontnum = Integer.parseInt(action.substring(WebMenuScreen.MENU_FONT_PREFIX.length()));
			this.setFontKey(fontnum);
		} else if(action.equals(WebMenuScreen.MENU_TABLES)) {
			this.setLayingOutTables(!this.isLayingOutTables());
		} else if(action.equals(WebMenuScreen.MENU_MAXIMIZE)) {
			this.setMaximized(!this.isMaximized());
		} else if(action.equals(WebMenuScreen.MENU_LEFT_BACK)) {
			this.setLeftSameAsBack(!this.isLeftSameAsBack());
		} else if(action.equals(WebMenuScreen.MENU_MOBILE)) {
			this.setAppearingMobile(!this.isAppearingMobile());
		} else if(action.startsWith(WebMenuScreen.MENU_STYLE_PREFIX)) {
			if(action.equals(WebMenuScreen.MENU_STYLE_SCREEN)) {
				this.setMediaStyleActive(MEDIA.SCREEN);
			} else if(action.equals(WebMenuScreen.MENU_STYLE_HANDHELD)) {
				this.setMediaStyleActive(MEDIA.HANDHELD);
			} else {
				this.setMediaStyleActive(MEDIA.TV);
			}
		}
	}

	public boolean isLeftSameAsBack() {
		return this.leftSameAsBack;
	}
	
	public void setLeftSameAsBack(boolean leftSameAsBack) {
		this.leftSameAsBack = leftSameAsBack;
		saveOptions();
	}

}
