package com.blackledge.david.html.hme;

import java.awt.Color;
import java.net.URL;
import java.text.MessageFormat;
import java.util.ArrayList;

import com.blackledge.david.html.hme.WebBrowserApp.MEDIA;
import com.blackledge.david.tivo.widgets.ActionButton;
import com.tivo.hme.bananas.BApplication;
import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlight;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BSkin;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.IHmeProtocol;
import com.tivo.hme.sdk.StreamResource;
import com.tivo.hme.sdk.View;

public class WebMenuScreen extends BScreen {

	public static final String MENU_PREFIX = "menu_"; //$NON-NLS-1$
	public static final String MENU_FONT_PREFIX = MENU_PREFIX + "font"; //$NON-NLS-1$
	public static final String MENU_STYLE_PREFIX = MENU_PREFIX+"style_"; //$NON-NLS-1$
	public static final String MENU_PIP = MENU_PREFIX + "pip"; //$NON-NLS-1$
	public static final String MENU_TABLES = MENU_PREFIX + "tables"; //$NON-NLS-1$
	public static final String MENU_STYLE_TV = MENU_STYLE_PREFIX + "tv"; //$NON-NLS-1$
	public static final String MENU_STYLE_HANDHELD = MENU_STYLE_PREFIX + "handheld"; //$NON-NLS-1$
	public static final String MENU_STYLE_SCREEN = MENU_STYLE_PREFIX + "screen"; //$NON-NLS-1$
	public static final String MENU_MOBILE = MENU_PREFIX + "mobile"; //$NON-NLS-1$
	public static final String MENU_MAXIMIZE = MENU_PREFIX + "maximize"; //$NON-NLS-1$
	public static final String MENU_LEFT_BACK = MENU_PREFIX + "left_back"; //$NON-NLS-1$
	public static final String MENU_LINK_THUMBTACK = MENU_PREFIX + "link_thumbtack"; //$NON-NLS-1$
	public static final String MENU_BRIGHTNESS = MENU_PREFIX + "brightness"; //$NON-NLS-1$
	private WebScreen webScreen;
//	private BView linkLabel;
	private BView brightnessCheck;
	private BView mobileCheck;
	private BView tableCheck;
	private BView[] fontCheck = new BView[9];
	private BView style_screen;
	private BView style_handheld;
	private BView style_tv;
	private ActionButton linkButton;
	private BView pipCheck;
	private int y;
	private BView buttonArea;
	private BView header;
	private BView icon;
	private BView maximizeCheck;
	private BView leftBackCheck;

	public WebMenuScreen(WebScreen webScreen) {
		this(webScreen.getBApp());
		
		this.webScreen = webScreen;
		
		BView firstView = null;
		int rowpadding = 15;
//		int labelGap = 7;
		int x = 0;
		ActionButton button;
//		BView label;
		Element skinBar = webScreen.getBApp().getSkin().get(BSkin.H_BAR);
		int minButtonWidth = skinBar.getInt("padh", 10)*2+skinBar.getInt("cap", 30); //$NON-NLS-1$ //$NON-NLS-2$
		int buttonWidth = buttonArea.getWidth()/3;
		buttonWidth = Math.max(minButtonWidth, buttonWidth);
		int buttonHeight = 24;
		buttonHeight = webScreen.getBApp().getSkin().get(BSkin.H_BAR).getHeight();
		String buttonFont = "default-15.font"; //$NON-NLS-1$
		buttonFont = "default-"+skinBar.getHeight()/3+".font"; //$NON-NLS-1$ //$NON-NLS-2$
		rowpadding = 0;
		
		y+=rowpadding;
//		label = makeLabel(buttonArea, x, y,"Web pages too bright for TV?");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_BRIGHTNESS);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		brightnessCheck = newCheckView(button);
		firstView = button;

		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Dimmer"))); //$NON-NLS-1$
		y += button.getHeight();
		y+=rowpadding;
		
		//move this to top
		y=0;
		button = new ActionButton(buttonArea, x, y, buttonArea.getWidth(), buttonHeight, MENU_LINK_THUMBTACK);
		button.setBarAndArrows(BAR_DEFAULT, BAR_HANG, "cancel", null, null, "down", false); //$NON-NLS-1$ //$NON-NLS-2$
		// content of this button will be left-aligned, so move it to the right as needed.
		button.setTranslation(skinBar.getInt("padh", 10), 0); //$NON-NLS-1$
		linkButton = button;
		linkButton.setResource(createText("default-12.font", Color.white, BookmarkScreen.BOOKMARK_NAME+" link:")); //$NON-NLS-1$ //$NON-NLS-2$
		y += button.getHeight();
//		y+= labelGap;
//		label = makeLabel(buttonArea, x, y, "(none)");
//		linkLabel = label;
//		y += label.getHeight();
		y+=rowpadding;
		
		this.setFocusDefault(firstView);
	}

	public WebMenuScreen(BApplication bApp) {
		super(bApp);
		WebBrowserApp wba = (WebBrowserApp) bApp;
		BView headerArea = new BView(getNormal(), getSafeTitleHorizontal()+wba.getSafeLogoToScrollTitle(), getSafeTitleVertical(),
				getNormal().getWidth()-getSafeTitleHorizontal()*2-wba.getSafeLogoToScrollTitle(), wba.getSafeTitleToScrollTop());
		headerArea.setResource(headerArea.createText("default-30.font", Color.yellow, Messages.getString("WebMenuScreen.Title")), RSRC_VALIGN_TOP | RSRC_HALIGN_CENTER); //$NON-NLS-1$ //$NON-NLS-2$
		int titleHeight = 30;
		header = new BView(headerArea, 0, titleHeight, headerArea.getWidth(), headerArea.getHeight()-titleHeight);
		icon = new BView(getNormal(), getSafeActionHorizontal(), getSafeTitleVertical(),
				wba.getSafeLogoToScrollTitle()+getSafeTitleHorizontal()-getSafeActionHorizontal(), wba.getSafeTitleToScrollTop());
		
		BView firstView = null;
		BView text = new BView(getNormal(), getSafeActionHorizontal(), 
				getSafeTitleVertical() + wba.getSafeTitleToScrollTop(),
				180,
				getNormal().getHeight() - getSafeTitleVertical() * 2
						- wba.getSafeTitleToScrollTop()
						- wba.getSafeTitleToScrollBottom());
		int defaultTextZoom = wba.getSavedFontKey();
		String textString = MessageFormat.format(Messages.getString("WebMenuScreen.controller_help"),BookmarkScreen.BOOKMARK_NAME, defaultTextZoom);  //$NON-NLS-1$
		text.setResource(text.createText("default-12.font", Color.yellow, textString),  //$NON-NLS-1$
				RSRC_HALIGN_RIGHT|RSRC_VALIGN_TOP|RSRC_TEXT_WRAP);
		buttonArea = new BView(getNormal(), text.getX()+text.getWidth(),
				getSafeTitleVertical()
						+ wba.getSafeTitleToScrollTop(),
				(getNormal().getWidth() - getSafeActionHorizontal() * 2)-text.getWidth(),
				getNormal().getHeight() - getSafeActionVertical() * 2
						- wba.getSafeTitleToScrollTop()
						- wba.getSafeTitleToScrollBottom());
		y = 0;
		int rowpadding = 15;
		int labelGap = 10;
		int x = 0;
		ActionButton button;
		BView label;
		int buttonWidth = buttonArea.getWidth()/3;
		Element skinBar = wba.getSkin().get(BSkin.H_BAR);
		int minButtonWidth = skinBar.getInt("padh", 10)*2+skinBar.getInt("cap", 30); //$NON-NLS-1$ //$NON-NLS-2$
		buttonWidth = Math.max(minButtonWidth, buttonWidth);
		int buttonHeight = 24;
		buttonHeight = skinBar.getHeight();
		String buttonFont = "default-15.font"; //$NON-NLS-1$
		buttonFont = "default-"+skinBar.getHeight()/3+".font"; //$NON-NLS-1$ //$NON-NLS-2$
		String buttonFontEmphasized = "default-"+(skinBar.getHeight()/3+1)+"-bolditalic.font"; //$NON-NLS-1$ //$NON-NLS-2$
		rowpadding = 0;
		labelGap = 2;
		y = rowpadding+buttonHeight; // make room for one row above everything here (the "current link" row)
		
		label = makeLabel(buttonArea, x, y, MessageFormat.format(Messages.getString("WebMenuScreen.text_zoom_label"),defaultTextZoom)); //$NON-NLS-1$
		int numButtonWidth =  Math.max(minButtonWidth, 45);
		y += label.getHeight();
		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+1);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.1"))); //$NON-NLS-1$
		fontCheck[0] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+2);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.2"))); //$NON-NLS-1$
		fontCheck[1] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+3);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.3"))); //$NON-NLS-1$
		fontCheck[2] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+4);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.4"))); //$NON-NLS-1$
		fontCheck[3] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+5);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFontEmphasized, Color.white, Messages.getString("WebMenuScreen.5"))); //$NON-NLS-1$
		fontCheck[4] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+6);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.6"))); //$NON-NLS-1$
		fontCheck[5] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+7);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.7"))); //$NON-NLS-1$
		fontCheck[6] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+8);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.8"))); //$NON-NLS-1$
		fontCheck[7] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+9);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.9"))); //$NON-NLS-1$
		fontCheck[8] = newCheckView(button);
		x = 0;
		y += button.getHeight();
		y+=rowpadding;
//		label = makeLabel(buttonArea, x, y, "Ask for mobile versions of pages");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_MOBILE);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Mobile_Mode"))); //$NON-NLS-1$
		mobileCheck = newCheckView(button);
		firstView = button;
		x += button.getWidth();
		x += 10; // add some space before the style mode button group
		button = new ActionButton(buttonArea, x, y, Math.max(minButtonWidth, 70), buttonHeight, MENU_STYLE_SCREEN);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, "screen")); //$NON-NLS-1$
		style_screen = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, Math.max(minButtonWidth, 90), buttonHeight, MENU_STYLE_HANDHELD);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, "handheld")); //$NON-NLS-1$
		style_handheld = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, Math.max(minButtonWidth, 50), buttonHeight, MENU_STYLE_TV);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		button.setResource(createText(buttonFont, Color.white, "tv")); //$NON-NLS-1$
		style_tv = newCheckView(button);
		
		x=0;
		y += button.getHeight();
		y+=rowpadding;
//		label = makeLabel(buttonArea, x, y, "Not laying out right? Try flattening tables");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_MAXIMIZE);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Maximize_Mode"))); //$NON-NLS-1$
		maximizeCheck = newCheckView(button);		
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_TABLES);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Table_Layout_Mode"))); //$NON-NLS-1$
		tableCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		x = 0;
		
		y += button.getHeight();
		y+=rowpadding;
		//FIXME change text if it's not flakey anymore
//		label = makeLabel(buttonArea, x, y, "Picture-in-Picture Live TV display (flakey - off by default)");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_PIP);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Live_TV_PIP_Mode"))); //$NON-NLS-1$
		pipCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_LEFT_BACK);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Left_Is_Back"))); //$NON-NLS-1$
		leftBackCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		x = 0;
		y += button.getHeight();
		
		this.setFocusDefault(firstView);
	}

	private BView makeLabel(BView buttonArea, int x, int y, String text) {
		BView label;
		label = new BView(buttonArea, x, y, buttonArea.getWidth(), 15);
		label.setResource(createText("default-15-bolditalic.font", Color.cyan, text), RSRC_HALIGN_LEFT | RSRC_VALIGN_BOTTOM); //$NON-NLS-1$
		return label;
	}
	
	private BView newCheckView(ActionButton button) {
		int wid = button.getHeight();
		int hei = wid;
		BView view = new BView(button, button.getWidth()-wid, 0, wid, hei);
		// FIXME need a nice image instead
		int padh = view.getBApp().getSkin().get(H_BAR).getInt("padh", 10); //$NON-NLS-1$
		view.setTranslation(-padh/2, 0);
		view.setResource(createText("system-30-bold.font",Color.green, "*"), RSRC_HALIGN_RIGHT | RSRC_VALIGN_CENTER); //$NON-NLS-1$ //$NON-NLS-2$
		return view;
	}
	
	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		switch(code) {
		case KEY_INFO:
			getBApp().pop();
			return true;
		case KEY_NUM1:
		case KEY_NUM2:
		case KEY_NUM3:
		case KEY_NUM4:
		case KEY_NUM5:
		case KEY_NUM6:
		case KEY_NUM7:
		case KEY_NUM8:
		case KEY_NUM9:
			int num = code - KEY_NUM0;
			postEvent(new BEvent.Action(fontCheck[num-1], MENU_FONT_PREFIX+num));
			break;
		case KEY_NUM0:
			int defaultTextSize = ((WebBrowserApp)getBApp()).getSavedFontKey();
			postEvent(new BEvent.Action(fontCheck[4], MENU_FONT_PREFIX+defaultTextSize));
			break;
		case KEY_CHANNELDOWN:
			//FIXME focus on bottom control
		case KEY_CHANNELUP:
			//FIXME focus on top control
		case KEY_ADVANCE:
			//FIXME focus on bottom, else top control
		}
		return super.handleKeyPress(code, rawcode);
	}
	
	@Override
	public boolean handleKeyRepeat(int code, long rawcode) {
		// support keyrepeat for navigation (handled by individual focusable elements)
		if(getFocus() != null) {
			switch (code) {
			case KEY_LEFT:
			case KEY_RIGHT:
			case KEY_UP:
			case KEY_DOWN:
				return getFocus().handleKeyPress(code, rawcode);
			}
		}
		return super.handleKeyRepeat(code, rawcode);
	}
	
	private void showBackground() {
		if(((WebBrowserApp)getBApp()).isShowingLiveTV()) {
			//FIXME have a good background image instead of this color
			getBelow().setResource(new Color(0, 0, 80));
		} else {
			StreamResource videoLoop = createStream(WebBrowserApp.STREAM_LOOP_BLUE_SETUP, "video/mpeg", true); //$NON-NLS-1$
			getBelow().setResource(videoLoop);
			flush();
		}
	}
	private void disposeBackground() {
		if(((WebBrowserApp)getBApp()).isShowingLiveTV()) {
		} else {
			if(getBelow().getResource() != null) {
				getBelow().getResource().remove();
				getBelow().clearResource();
				flush();
			}
		}
	}

	@Override
	public boolean handleEnter(Object arg, boolean isReturn) {
		showBackground();
		String headerText = 
				WebBrowserApp.BROWSER_NAME;
		if(webScreen != null) {
			headerText = 
					webScreen.getTitle()+"\n"+ //$NON-NLS-1$
					webScreen.getURL();
			icon.setResource(webScreen.getIconURL(), RSRC_HALIGN_RIGHT | RSRC_VALIGN_BOTTOM | RSRC_IMAGE_BESTFIT);
		}
		header.setResource(header.createText("system-15-italic.font", Color.white, headerText), RSRC_HALIGN_LEFT | RSRC_VALIGN_TOP); //$NON-NLS-1$
		
		WebBrowserApp web = ((WebBrowserApp)getBApp());
		if(tableCheck != null)
		tableCheck.setVisible(web.isLayingOutTables());
		if(maximizeCheck != null)
		maximizeCheck.setVisible(web.isMaximized());
		if(mobileCheck != null)
		mobileCheck.setVisible( web.isAppearingMobile());
		if(style_handheld != null)
		style_handheld.setVisible( web.isMediaStyleActive(MEDIA.HANDHELD));
		if(style_screen != null)
		style_screen.setVisible( web.isMediaStyleActive(MEDIA.SCREEN));
		if(style_tv != null)
		style_tv.setVisible( web.isMediaStyleActive(MEDIA.TV));
		if(pipCheck != null)
		pipCheck.setVisible( web.isShowingLiveTV());
		if(leftBackCheck != null)
		leftBackCheck.setVisible( web.isLeftSameAsBack());
		if(brightnessCheck != null && webScreen != null)
		brightnessCheck.setVisible(webScreen.isShaded());
		for(int i = 0 ; i < fontCheck.length ; ++i) {
			if(fontCheck[i]!=null)
			fontCheck[i].setVisible(false);
		}
		int fontIndex = web.getFontScaleKey()-1;
		if(fontIndex < fontCheck.length && fontIndex >= 0) {
			if(fontCheck[fontIndex]!=null)
			fontCheck[fontIndex].setVisible(true);
		}
		
		if(webScreen != null && linkButton != null 
//				&& linkLabel != null
				) {
		String text = webScreen.getFocusedLinkText();
		// hide link controls if there isn't a valid current one.
//		linkLabel.setVisible(text!=null);
		linkButton.setVisible(text!=null);
		linkButton.getHighlights().setVisible(BHighlight.H_BAR, text!=null?BHighlight.H_VIS_TRUE:BHighlight.H_VIS_FALSE);
//		URL url = webScreen.getFocusedLinkURL(null);
//		if(text!= null && text.equals(url.toString())) {
//			text = text+" ("+url+")";
//		}
		if(text != null) {
			if(linkButton.getResource() != null)
				linkButton.getResource().remove();
			Element skinBar = webScreen.getBApp().getSkin().get(BSkin.H_BAR);
			String buttonFont = "default-"+skinBar.getHeight()/3+".font"; //$NON-NLS-1$ //$NON-NLS-2$
			linkButton.setResource(createText(buttonFont, Color.white,
					MessageFormat.format(Messages.getString("WebMenuScreen.Save_Link"), BookmarkScreen.BOOKMARK_NAME, text)),     //$NON-NLS-1$
					RSRC_HALIGN_LEFT | RSRC_VALIGN_CENTER);
//			linkLabel.setResource(createText("default-20-bolditalic.font", Color.yellow, text), RSRC_HALIGN_LEFT |RSRC_VALIGN_CENTER);
		}
		if (!isReturn && text != null) {
			setFocus(linkButton);
			return true;
		}
		}
		// super implementation focuses on focusDefault
		return super.handleEnter(arg, isReturn);
	}
	
	@Override
	public boolean handleExit() {
		disposeBackground();
		removeTextResources(this);
		return super.handleExit();
	}
	
	private void removeTextResources(WebMenuScreen webMenuScreen) {
		removeAllChildren(webMenuScreen.getNormal());
	}
	private void removeAllChildren(View parent) {
		// collect the views before removing them, otherwise the getChild call
		// gets thrown by the remove calls.
		ArrayList<View> children = new ArrayList<View>();
		for(int i = 0 ; i < parent.getChildCount() ; ++i) {
			 children.add( parent.getChild(i));
		}
		
		for(View child : children) {
			removeAllChildren(child);
			if(child.getResource() != null) {
				if(child.getResource().getClass().getName().contains("Text")) { //$NON-NLS-1$
					child.getResource().remove();
				}
			}
			child.clearResource(); // resource's own finalize will remove itself from tivo
			// make sure focus gets cleared if the one we're removing has it.
			if(child.hasFocus()) {
				this.setFocus(null);
			}
			child.remove();
		}
	}
	
	@Override
	public boolean handleAction(BView view, Object action) {
		if( super.handleAction(view, action)) {
			return true;
		} else if (action.equals(H_UP) || action.equals(H_DOWN)
				|| action.equals(H_LEFT) || action.equals(H_RIGHT)) {
			// if super didn't handle it, it couldn't find a match.
			return false;
		} else if (action.equals("cancel")) { //$NON-NLS-1$
			getBApp().pop();
			return true;
		
		} else {
			getBApp().pop(action);
			return true;
		}
	}

}
