package com.blackledge.david.html.hme;

import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class YouTubeLauncher {

	private static final Pattern youtubeVideoPattern = Pattern.compile(".*youtube\\.com/(watch|v/).*");
	public static boolean isYouTubeVideo(URL url) {
		if(url == null) return false;
		boolean result = youtubeVideoPattern.matcher(url.toString()).matches();
//		WebBrowserApp.debugOut("YOUTUBE TEST:"+url+" "+result);
		return result;
	}
	
	private static final Pattern videoIdPattern = Pattern.compile(".*(\\?|\\/|\\&)v(\\=|\\/)([^&\\?]+).*");
	public static boolean launchVideo(URL youtubeURL, WebBrowserApp browser) {
		if(youtubeURL == null) return false;
//"http://www.youtube.com/watch?v=N0GuGiycMs0"
//"http://m.youtube.com/watch?v=N0GuGiycMs0"
//"http://www.youtube.com/v/N0GuGiycMs0?autohide=1&amp;version=3"
		 // the v= id of the video (jumpTo=VIDEO)
		Matcher idMatcher = videoIdPattern.matcher(youtubeURL.getFile());
		if(idMatcher.find() && idMatcher.groupCount() >= 3) {
			String v = idMatcher.group(3);
			try {
				URL youTubeHME = new URL("hme://204.176.49.116:7288/youtube" 
								+ "?" 
								+ "jumpTo=VIDEO"
								+ "&" 
								+ "videoid="+v
						);
				browser.loadApp(youTubeHME);
				return true;
			} catch (MalformedURLException e) {
				// FIXME Auto-generated catch block
				e.printStackTrace();
			}
		}
		WebBrowserApp.debugOut("YOUTUBE : groupCount="+idMatcher.groupCount()+" "+youtubeURL.getQuery());
		return false;
	}

	public static boolean launchSearch(String query, WebBrowserApp browser) {
//		"jumpTo" // "VIDEO" or "SEARCH"
//		"query" // jumpTo=SEARCH
		try {
			URL youTubeHME = new URL("hme://204.176.49.116:7288/youtube" 
							+ "?" 
							+ "jumpTo=SEARCH"
							+ "&" 
							+ "query="+URLEncoder.encode(query, "UTF-8")
					);
			browser.loadApp(youTubeHME);
			return true;
		} catch (MalformedURLException e) {
			// FIXME Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}

	
// per moyekj on tivocommunity.com...
//	YouTube on series 4 units is a Flash app, not HME. The HME version doesn't show up in my search. Here's the details on the Flash version:
//		Code:
//		{
//		"instanceName":"YouTube Leanback",
//		"instanceParameter":[
//		 {
//		  "type":"fieldDefinition",
//		  "valueType":"string",
//		  "truncate":false,
//		  "skipInOutput":false,
//		  "minOccurs":0,
//		  "description":"Search query, with words separated by the '+' sign. Used to launch app with a specific search query.",
//		  "copyValueFrom":"Collection.title",
//		  "ignoreInInput":false,
//		  "name":"q",
//		  "levelOfDetail":"high",
//		  "isNote":false
//		 },
//		 {
//		  "type":"fieldDefinition",
//		  "valueType":"string",
//		  "truncate":false,
//		  "skipInOutput":false,
//		  "minOccurs":0,
//		  "description":"YouTube Video ID. Used to launch app with a specific video.",
//		  "copyValueFrom":"Offer.partnerOfferId",
//		  "ignoreInInput":false,
//		  "name":"v",
//		  "levelOfDetail":"high",
//		  "isNote":false}
//		],
//		"type":"uiDestinationInstance",
//		"uiDestinationType":"flash",
//		"levelOfDetail":"high",
//		"uiDestinationInstanceId":"tivo:di.1000851",
//		"instanceDescription":"YouTube Leanback",
//		"uri":"x-tivo:flash:uuid:B8CEA236-0C3D-41DA-9711-ED220480778E",
//		"serviceGroup":["DG_flash_youtube","DG_hme_youtube_leanback_alpha","DG_hme_youtube_leanback_beta","DG_hme_youtube_leanback_qe"],
//		"description":"YouTube app","uiDestinationId":"tivo:ud.1000251",
//		"name":"YouTube",
//		"parameter":[
//		 {
//		  "type":"fieldDefinition",
//		  "valueType":"string",
//		  "truncate":false,
//		  "skipInOutput":false,
//		  "minOccurs":0,
//		  "description":"VIDEO or SEARCH",
//		  "ignoreInInput":false,
//		  "name":"jumpTo",
//		  "levelOfDetail":"high",
//		  "isNote":false
//		 },
//		 {
//		  "type":"fieldDefinition",
//		  "valueType":"string",
//		  "truncate":false,
//		  "skipInOutput":false,
//		  "minOccurs":0,
//		  "description":"If jumpto=VIDEO, this should be set to specify which video to play. You can find the video id from the url when watching a youtube video, the v= is the video id",
//		  "ignoreInInput":false,
//		  "name":"videoid",
//		  "levelOfDetail":"high",
//		  "isNote":false
//		 },
//		 {
//		  "type":"fieldDefinition",
//		  "valueType":"string",
//		  "truncate":false,
//		  "skipInOutput":false,
//		  "minOccurs":0,
//		  "description":"If jumpto=SEARCH, this should be set to specify the string to search for.",
//		  "ignoreInInput":false,
//		  "name":"query",
//		  "levelOfDetail":"high","isNote":false
//		 }
//		],
//		"priority":800
//		}	
}
