package com.blackledge.david.html.hme.host;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.HttpCookie;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

import com.blackledge.david.html.hme.WebBrowserApp;
import com.tivo.hme.host.http.server.HttpConnection;
import com.tivo.hme.host.http.server.HttpRequest;
import com.tivo.hme.host.http.server.HttpServer;
import com.tivo.hme.host.util.Config;
import com.tivo.hme.interfaces.ILogger;

public class TiVoConnect extends HttpServer {

	private boolean DEBUG;
	private ILogger logger;

	public TiVoConnect(Config config, ILogger logger) throws IOException {
		super(config);
//System.out.println("TiVoConnect set up!");
        this.logger = logger;

        DEBUG = config.getBool("listener.debug", false);
//        tm0 = System.currentTimeMillis();
//        
//        config.put("http.acceptor.name", ACCEPTOR_NAME);

        start();
	}

	@Override
	public void handle(HttpRequest request) throws IOException {
		if(request.getURI().contains("TiVoConnect")) {
			System.out.println(request.getURI());
			System.out.println(request.getInetAddress());
			System.out.println(request.getHeaders());
				//			String query = "";
				//			Iterator keys = request.getHeaders().getKeys();
				//			while (keys.hasNext()) {
				//				String key = (String) keys.next();
				//				String value = request.getHeaders().get(key);
				//				query += URLEncoder.encode(key, "UTF-8");
				//				if(value != null) {
				//					query += "="+URLEncoder.encode(value, "UTF-8");
				//				}
				//				if(keys.hasNext())
				//					query += "&";
				//			}
							
			String response = this.toString(request);
			
//System.out.println("RESPONDING with:"+response);
			request.reply(HTTP_STATUS_OK, "");
			// currently sending:
//			{Content-length=6627, 
//			Server=HttpServer}			
			// Premiere says:
//			{Transfer-Encoding=chunked, 
//			Date=Thu, 03 Jan 2013 20:49:38 GMT, 
//			Keep-Alive=timeout=5, max=100, 
//			Content-Type=text/xml, 
//			Connection=Keep-Alive, 
//			Server=Apache}
			request.addHeader("Content-Type", "text/xml");
			
			byte[] bytes = response.getBytes();
			OutputStream outputStream = request.getOutputStream(bytes.length);
			outputStream.write(bytes);
//				System.out.println("RESPONSE WRITTEN");
		} else if(request.getURI().contains("EnterWebzTest")) {
			
			File testFile = new File("C:\\Users\\David\\EnterWebzTest.html");
			byte[] bytes = new byte[(int) testFile.length()];
			FileInputStream fis = new FileInputStream(testFile);
			fis.read(bytes);
			fis.close();
			request.reply(HTTP_STATUS_OK, "");
			request.addHeader("Content-Type", "text/html");
			HttpCookie testcookie = new HttpCookie("test2", "test2value");
			testcookie.setMaxAge(1000*100);
			testcookie.setPath("/");
			request.addHeader("Set-Cookie", testcookie.toString());
			request.addHeader("Set-Cookie", "test3=test3value");
			OutputStream outputStream = request.getOutputStream(bytes.length);
			outputStream.write(bytes);
		
		} else if(request.getURI().contains("EnterWebzImg")) {
			System.out.println(request.getURI());
			System.out.println(request.getInetAddress());
			System.out.println(request.getHeaders());
			
			File testFile = new File("C:\\Users\\David\\EnterWebzImg.png");
			byte[] bytes = new byte[(int) testFile.length()];
			FileInputStream fis = new FileInputStream(testFile);
			fis.read(bytes);
			fis.close();
			request.reply(HTTP_STATUS_OK, "");
			request.addHeader("Content-Type", "image/png");
			OutputStream outputStream = request.getOutputStream(bytes.length);
			outputStream.write(bytes);
		
		} else {
			request.reply(HTTP_STATUS_NOT_FOUND, "Only TiVoConnect supported");
		}
							
				//			response = "\r\n" + 
				//					"<TiVoContainer>\r\n" + 
				//					"<Details>\r\n" + 
				//					"  <ContentType>x-container/tivo-server</ContentType>\r\n" + 
				//					"  <SourceFormat>x-container/folder</SourceFormat>\r\n" + 
				//					"  <TotalItems>1</TotalItems>\r\n" + 
				//					"  <Title>MP3tunes HME Server</Title>\r\n" + 
				//					"</Details>\r\n" + 
				//					"<ItemStart>0</ItemStart>\r\n" + 
				//					"<ItemCount>1</ItemCount>\r\n" + 
				//					"<Item>\r\n" + 
				//					"  <Details>\r\n" + 
				//					"    <ContentType>application/x-hme</ContentType>\r\n" + 
				//					"    <SourceFormat>x-container/folder</SourceFormat>\r\n" + 
				//					"    <Title>MP3tunes Locker</Title>\r\n" + 
				//					"  </Details>\r\n" + 
				//					"  <Links>\r\n" + 
				//					"    <Content>\r\n" + 
				//					"      <Url>http://168.143.122.40:7288/mp3tunes/</Url>\r\n" + 
				//					"    </Content>\r\n" + 
				//					"  </Links>\r\n" + 
				//					"</Item>\r\n" + 
				//					"</TiVoContainer>";
							
				//			totalItems=1;
				//			response = "  <TiVoContainer> \r\n" + 
				//					"   <Details> \r\n" + 
				//					"    <ContentType>\r\n" + 
				//					"     x-container/tivo-server\r\n" + 
				//					"    </ContentType> \r\n" + 
				//					"    <SourceFormat>\r\n" + 
				//					"     x-container/folder\r\n" + 
				//					"    </SourceFormat> \r\n" + 
				//					"    <Title>TiVo Server</Title> \r\n" + 
				//					"    <TotalItems>\r\n" + 
				//					"     " +
				//					totalItems +
				//					"\r\n" + 
				//					"    </TotalItems> \r\n" + 
				//					"   </Details> \r\n" + 
				//					"   <ItemCount>\r\n" + 
				//					"    " +
				//					totalItems +
				//					"\r\n" + 
				//					"   </ItemCount> \r\n" + 
				//					"   <ItemStart>\r\n" + 
				//					"    0\r\n" + 
				//					"   </ItemStart> \r\n" + 
									
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Credit Card Update (PCI enabled)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      984BBCD1-F705-6F3C-8E1A-BA7F4C26B570\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      15\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.59:7287/CreditCard_20080912-20080912_131340/1221250421/1289849840-1605209840/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/CreditCard_20080912-20080912_131340/1221250421/1289849840-1605209840/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Buy a TiVo Premiere</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      0F64DC01-096D-D7A9-1145-060E26DD0CE5\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      3\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.59:7287/TivoUpgrade-20120424_122953/1335295796/1335399021-1650759021/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/TivoUpgrade-20120424_122953/1335295796/1335399021-1650759021/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" +
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Amazon v1.9 (2010.10.25-0632)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      35FE011C-3850-2228-FBC5-1B9EDBBE5863\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/amazon-1-9.2011.03.16-0632-20110316_154048/1300315250/1317939394-1633299394/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/amazon-1-9.2011.03.16-0632-20110316_154048/1300315250/1317939394-1633299394/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Order Domino's Pizza Now</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      6BA2A86B-619B-67A6-BFA3-0E137B167A5A\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      21\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/dominos.2009.05.07.r1021.logerror.signed-20090507_174812/1241743696/1289849802-1605209802/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/dominos.2009.05.07.r1021.logerror.signed-20090507_174812/1241743696/1289849802-1605209802/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Browse and Buy Movie Tickets</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      B9DDBECF-BC6D-5E33-388A-4CF840068D79\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      30\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/fandivo-1.1.2011.11.10-1645-20111115_112508/1321385109/1343238702-1658598702/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/fandivo-1.1.2011.11.10-1645-20111115_112508/1321385109/1343238702-1658598702/icon_SD.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Photos &amp; Slideshows</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      BBC7824A-40C6-8B61-4D87-6A3D799F365B\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      47\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/hdphotos-ml_2010.09.13-1339-20100913_134517/1284410719/1343239081-1658599081/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/hdphotos-ml_2010.09.13-1339-20100913_134517/1284410719/1343239081-1658599081/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Hme Down</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      9D99EC4B-B08C-191C-3255-40B58B1F5DAF\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/hmedown_20080317-20080402_170823/1207181304/1240249987-1587405187/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/hmedown_20080317-20080402_170823/1207181304/1240249987-1587405187/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Guru Guides (3/08 - 1143)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      403871C3-A324-21B8-1D8D-826834E758EB\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/kidzone_v1.0-20100622-20100622_141902/1277241543/1289849391-1605209391/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/kidzone_v1.0-20100622-20100622_141902/1277241543/1289849391-1605209391/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>KidZone (3/8-1143)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      5D524EE8-B977-1DC8-CD30-39BF60E7749C\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/kidzone_v1.0-20100622-20100622_141902/1277241543/1289849349-1605209349/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/kidzone_v1.0-20100622-20100622_141902/1277241543/1289849349-1605209349/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Live365</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      9B26EF4C-BF08-A9A5-F18E-F898DA9ADEB6\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      35\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/live365-1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/live365-1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Music Videos from Music Choice</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      49\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/musicchoice-1.0-2010.08.04-0632-20100804_161353/1280963634/1328046275-1643406275/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/musicchoice-1.0-2010.08.04-0632-20100804_161353/1280963634/1328046275-1643406275/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Podcaster</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      6838E9A3-F968-683E-110E-6591066452A1\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      45\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/podcast-20100730-qbert-20100730_180250/1280538174/1343239384-1658599384/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/podcast-20100730-qbert-20100730_180250/1280538174/1343239384-1658599384/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>SameGame</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      DC47F5CD-C97F-1C8F-EA91-CDDB4CFA1EFA\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      65\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/samegame_20071012_01-20080402_173700/1207183021/1343239500-1658599500/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/samegame_20071012_01-20080402_173700/1207183021/1343239500-1658599500/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Skull &amp; Bones</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      1A73F688-60B2-561D-BBEA-354BB36D3DA4\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      80\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/skullbones_20071012-20080402_173743/1207183066/1343239554-1658599554/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/skullbones_20071012-20080402_173743/1207183066/1343239554-1658599554/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Survey App</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      5A695917-238E-4218-8066-D4713A314063\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/survey_20080530-01_signed-20080530_150815/1212185297/1289848835-1605208835/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/survey_20080530-01_signed-20080530_150815/1212185297/1289848835-1605208835/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Swivel 2.8 U.S. Jump Target  (03/16/11-0631)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      49C791F9-7D48-38AB-8177-9C756D4EE2C0\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      50\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-20120508_094009/1336495211/1336595307-1651955307/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-20120508_094009/1336495211/1336595307-1651955307/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Swivel 2.8 (03/16/11-0631)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      2BD40EF7-D9D2-3CD4-0130-6C18855CE898\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      50\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-20120508_094009/1336495211/1336595232-1651955232/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-20120508_094009/1336495211/1336595232-1651955232/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>TiVoCast 2.8 (2011.03.16-0115)</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      19452283-D00B-C411-595D-447ABF62F37C\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/tivocast-2.8-2012-06-26-0603at563743-20120626_120132/1340737293/1344881428-1660241428/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/tivocast-2.8-2012-06-26-0603at563743-20120626_120132/1340737293/1344881428-1660241428/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <Hidden /> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Video Player</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      863CB78F-EFDD-4106-B572-51733983DC76\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       https://204.176.49.65:7287/videoplayer-0023-release-sst-20090716_122445/1247772287/1333658049-1649018049/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/videoplayer-0023-release-sst-20090716_122445/1247772287/1333658049-1649018049/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"   <Item> \r\n" + 
				//					"    <Details> \r\n" + 
				//					"     <ContentType>\r\n" + 
				//					"      application/x-hme\r\n" + 
				//					"     </ContentType> \r\n" + 
				//					"     <SourceFormat>\r\n" + 
				//					"      x-container/folder\r\n" + 
				//					"     </SourceFormat> \r\n" + 
				//					"     <Title>Wordsmith</Title> \r\n" + 
				//					"     <Uuid>\r\n" + 
				//					"      41731A91-6B5D-7E7D-C495-9A1F399965C7\r\n" + 
				//					"     </Uuid> \r\n" + 
				//					"     <X-TiVo-TopLevelDisplayOrderHint>\r\n" + 
				//					"      70\r\n" + 
				//					"     </X-TiVo-TopLevelDisplayOrderHint> \r\n" + 
				//					"    </Details> \r\n" + 
				//					"    <Links> \r\n" + 
				//					"     <Content> \r\n" + 
				//					"      <ContentType>\r\n" + 
				//					"       application/x-hme\r\n" + 
				//					"      </ContentType> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/wordsmith_20071012-20080402_180020/1207184421/1343239627-1658599627/clientip_67.0.59.230/\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </Content> \r\n" + 
				//					"     <CustomIcon> \r\n" + 
				//					"      <Url>\r\n" + 
				//					"       http://204.176.49.116:7288/wordsmith_20071012-20080402_180020/1207184421/1343239627-1658599627/icon.png\r\n" + 
				//					"      </Url> \r\n" + 
				//					"     </CustomIcon> \r\n" + 
				//					"    </Links> \r\n" + 
				//					"   </Item> \r\n" + 
				
				//					"  </TiVoContainer> \r\n" + 
				//					"";
							
					}

	private String toString(HttpRequest request) {
		if (request == null
				|| request.get(WebBrowserApp.HTTP_HEADER_TIVO_ID) == null) {
			return toString();
		}
		String tsn = request.get(WebBrowserApp.HTTP_HEADER_TIVO_ID);

		return toString(getHMEItems(tsn, request.getURI()));
	}

	public String toString() {
			
		HMEItem[] items = getHMEItems(null, null);
		String response = toString(items);
		return response;
	}

	private HMEItem[] getHMEItems(String tsn, String uri) {
		//FIXME use tsn to get items from tsn-specific file
		HMEItem[] items = new HMEItem[] {
				new HMEItem("Enter Webz!",
						"http://192.168.0.20:7288/webz/",
						"http://192.168.0.20:7288/webz/icon.png", "dlb-Enter_Webz",
						null)
				,
				new HMEItem("Youtube Website",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://youtube.com"),
						"http://s.ytimg.com/yts/img/favicon_32-vflWoMFGx.png", "dlb-enterwebz-youtube.com",
						HMEItem.GENRE_VIDEO)
				,
				new HMEItem("Feature Films at Archive.org",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://archive.org/details/feature_films"),
						"http://www.archive.org/images/glogo.jpg", "dlb-enterwebz-archive.org-feature_films",
						HMEItem.GENRE_VIDEO)
				,
				new HMEItem("Classic TV at Archive.org",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://archive.org/details/classic_tv"),
						"http://www.archive.org/images/glogo.jpg", "dlb-enterwebz-archive.org-classic_tv",
						HMEItem.GENRE_VIDEO)
				,
				new HMEItem("Animation and Cartoons at Archive.org",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://archive.org/details/animationandcartoons"),
						"http://www.archive.org/images/glogo.jpg", "dlb-enterwebz-archive.org-animationandcartoons",
						HMEItem.GENRE_VIDEO)
				,
				new HMEItem("Live Concerts at Archive.org",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://archive.org/details/etree"),
						"http://www.archive.org/images/glogo.jpg", "dlb-enterwebz-archive.org-etree",
						HMEItem.GENRE_MUSIC)
				,
				new HMEItem("Radio Programs at Archive.org",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://archive.org/details/radioprograms"),
						"http://www.archive.org/images/glogo.jpg", "dlb-enterwebz-archive.org-radioprograms",
						HMEItem.GENRE_MUSIC)
				,
				new HMEItem("Audio Books and Poetry at Archive.org",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://archive.org/details/audio_bookspoetry"),
						"http://www.archive.org/images/glogo.jpg", "dlb-enterwebz-archive.org-audio_bookspoetry",
						HMEItem.GENRE_MUSIC)
				,
				
				new HMEItem("Weather",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("http://m.wund.com/cgi-bin/findweather/getForecast?brand=mobile&query=87123"),
						"http://icons.wunderground.com/graphics/smalllogo.gif", "dlb-enterwebz-m.wund.com",
						null)
				,
				new HMEItem("IMDB",
						"http://192.168.0.20:7288/webz2/?url="+urlEncode("http://m.imdb.com/"),
//						"http://i.media-imdb.com/images/SF0ae8798307d147d8ea59044184b4339e/mobile/icon_114x114.png",
						null,
						"dlb-enterwebz-imdb.com", null)
				,
				new HMEItem("Dominos app",
						"http://192.168.0.20:7288/webz/?url="+urlEncode("hme://204.176.49.116:7288/dominos"),
						"http://204.176.49.116:7288/dominos.2009.05.07.r1021.logerror.signed-20090507_174812/1241743696/1289849802-1605209802/icon.png", "dlb-enterwebz-hme:dominos",
						null)
				,
				new HMEItem("Google",
						"http://192.168.0.20:7288/webz2/?fontScale=1.5&url="+urlEncode("http://www.google.com/"),
//						"http://www.google.com/images/google_favicon_128.png", 
						null,
						"dlb-enterwebz-www.google.com",
						null)
				,
				new HMEItem("Google Image Search",
						"http://192.168.0.20:7288/webz2/?fontScale=1.5&url="+urlEncode("http://www.google.com/imghp"),
						null,
						"dlb-enterwebz-www.google.com-imghp",
						HMEItem.GENRE_PHOTOS)
				,
				new HMEItem("Photos.com",
						"http://192.168.0.20:7288/webz2/?fontScale=1.5&url="+urlEncode("http://photos.com"),
						null,
						"dlb-enterwebz-photos.com",
						HMEItem.GENRE_PHOTOS)
				,
				new HMEItem("National Geographic Photography",
						"http://192.168.0.20:7288/webz2/?fontScale=1.5&url="+urlEncode("http://photography.nationalgeographic.com"),
						null,
						"dlb-enterwebz-photo-nat-geo",
						HMEItem.GENRE_PHOTOS)
				,
				new HMEItem("Awkward Family Photos",
						"http://192.168.0.20:7288/webz2/?fontScale=1.5&url="+urlEncode("http://awkwardfamilyphotos.com"),
						null,
						"dlb-enterwebz-awkwardfamilyphotos.com",
						HMEItem.GENRE_PHOTOS)
//				,
//				new HMEItem("David's Calendar",
//						"http://192.168.0.20:7288/webz1/?fontScale=1.5&url="+urlEncode(
//				"https://www.google.com/calendar/embed?src=davidlblackledge%40gmail.com&ctz=America/Denver&mode=AGENDA"
//								),
////						"http://www.google.com/images/google_favicon_128.png", 
//						null,
//						"dlb-davidscalendar", null)
,

new HMEItem("gmail html?",
		"http://192.168.0.20:7288/webz1/?url="+urlEncode("http://mail.google.com/mail/x/?ui=html"),
//		"http://www.google.com/images/google_favicon_128.png",
		null,
		"dlb-enterwebz-mail.google.com-html",
		null)

						
//					,
//					new HMEItem("Save to Video Whitebox",
//							"http://192.168.0.20:7288/webz/?fontScale=1.5&url="+urlEncode("http://192.168.0.21:9032"),
//							"http://www.google.com/images/google_favicon_128.png")
//					,
//					new HMEItem("Whitebox TwonkyMedia Music",
//							"http://192.168.0.20:7288/webz/?fontScale=1.5&url="+urlEncode("http://192.168.0.9:9000/webbrowse"),
//							"http://www.google.com/images/google_favicon_128.png")
		};

		//FIXME eh? strange way to do this.  pass boolean in during toString instead
		if(uri != null && uri.contains("DoGenres=1")) {
			for(HMEItem item : items) {
				item.genres=true;
			}
		}
		
		
		// didn't work as hoped
//		// set uuid of the Video Player
//		items[0].uuid = "863CB78F-EFDD-4106-B572-51733983DC76"; 

		return items;
	}

	private String toString(HMEItem[] items) {
		String serverTitle = "Enter Webz Server";
		int totalItems = items == null? 0 : items.length;
//							String title = "asdfasfafEnter Webz";
//							String url = "http://192.168.0.20:7288/webz";//FIXME build url
//				//			if(query != null && query.length() > 0) {
//				//				url += "?"+query;
//				//			}
//				System.out.println(url);
			
			
		String response = 
				"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>" + "\n" +
				"  <TiVoContainer>" + "\n" +
				"   <Details>" + "\n" +
				"    <ContentType>x-container/tivo-server</ContentType>" + "\n" +
				"    <SourceFormat>x-container/folder</SourceFormat>" + "\n" +
				"    <Title>" + serverTitle + "</Title>" + "\n" +
				"    <TotalItems>" + totalItems + "</TotalItems>" + "\n" +
				"   </Details>" + "\n" +
				"   <ItemCount>" + totalItems + "</ItemCount>" + "\n" +
				"   <ItemStart>0</ItemStart>" + "\n";
		if(items != null)
		for(HMEItem item : items) {
			response += "" + item.toString();
		}
		response +=
				"  </TiVoContainer>";
		return response;
	}
	
	private String urlEncode(String arg) {
		try {
			return URLEncoder.encode(arg, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			return arg;
		}
	}

	@Override
	protected void handleException(Object context, Throwable t) {
		// TODO Auto-generated method stub
		super.handleException(context, t);
	}

}
