package com.blackledge.david.tivo.widgets.typo;

import com.tivo.hme.bananas.BApplication;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.interfaces.IContext;
import com.tivo.hme.sdk.StreamResource;

public class TyPoScreen extends BScreen {
	
	private TyPo typo;

	public TyPoScreen(BApplication bapp) {
		this(bapp, -1);
	}

	/**
	 * @param bapp
     * @param protocolVersion the "version" parameter passed in during {@link com.tivo.hme.sdk.Application#setContext(IContext, int)}
	 */
	public TyPoScreen(BApplication bapp, int protocolVersion) {
		super(bapp);
		int typoheight = 20;
		typoheight = getHeight()/25;
		BView parent = this.getNormal();
		this.typo = new TyPo(parent, 
				getSafeTitleHorizontal(),
				(parent.getHeight()/2) - (typoheight/2),
				parent.getWidth() - 2 * getSafeTitleHorizontal()
				-100// make room for tips
				, 
//				getAbove().getHeight() - 2 * getSafeTitleVertical(),
				typoheight,
				true, protocolVersion);
		this.typo.setActivateOnFocus(true);
		this.typo.setExitOptions(TyPo.EXIT_CANCEL, TyPo.EXIT_FINISHED, false, false, false, false);
		this.setFocusDefault(this.typo);
	}

	public TyPo getTyPo() {
		return this.typo;
	}
	
	
	private void showBackground() {
		StreamResource videoLoop = createStream("loopset:NowPlaying", "video/mpeg", true);
		getBelow().setResource(videoLoop);
		flush();
	}
	private void disposeBackground() {
		if(getBelow().getResource() != null) {
			getBelow().getResource().remove();
			getBelow().clearResource();
			flush();
		}
	}

	@Override
	public boolean handleEnter(Object arg, boolean isReturn) {
		showBackground();
		
		super.handleEnter(arg, isReturn);
		typo.activateNow();
//		typo.setFocus();
		if(arg != null) {
			this.typo.setValue(arg.toString());
		}
		
		return true;
	}
	
	@Override
	public boolean handleExit() {
		disposeBackground();
		return super.handleExit();
	}
	
	@Override
	public boolean handleAction(BView view, Object action) {
		if(! super.handleAction(view, action) ) {
			if (action != null && action.equals(typo.getCancelAction())
					|| action.equals(typo.getFinishedAction())) {
				getBApp().pop(action);
				return true;
			}
		}
		return false;
	}

}
